#ifndef WAPI_H
#define WAPI_H

// Cdigos de erros de execuo
// OBS: Erros de argumentos de linha de comando no so sinalizados
#define _kERROR_NONE                  0 // sucesso
#define _kERROR_PARAMETERS           -1 // erro na passagem dos parmetros
#define _kERROR_PARAMETERS_FILE      -2 // erro na abertura do arquivo de parmetros
#define _kERROR_OPEN_INPUTFILE       -3 // erro na abertura do arquivo de entrada de dados
#define _kERROR_OPEN_PRINTER         -4 // erro na abertura da impressora
#define _kERROR_OPEN_RESULTFILE      -5 // erro na abertura do arquivo de resultado
#define _kERROR_READ_RESULTFILE      -6 // erro na leitura do arquivo de resultado
#define _kERROR_UNDEF_PRINTER        -7 // nenhuma impressora definida
#define _kERROR_PRINT_NO_INDEX       -8 // erro na criao do ndice das pginas
#define _kERROR_PRINT_NO_PAGES       -9 // aps filtragem, nenhuma pgina para imprimir
#define _kERROR_PRINT_START_DOC     -10 // erro ao informar a API do incio do documento
#define _kERROR_PRINT_START_PAGE    -11 // erro ao informar a API do incio de uma pgina
#define _kERROR_MEMORY              -12 // alocao de memria negada
#define _kERROR_MEMORY_LOCKED       -13 // memria (globalAlloc) bloqueada por outra aplicao
#define _kERROR_MEMORY_INSUFFICIENT -14 // memria alocada insuficiente para realizar operao
#define _kERROR_TIMEOUT             -19 // tempo de espera esgotado
#define _kERROR_GENERIC             -20 // erro genrico, no especificado
#define _kERROR_CLIPBOARD_UNDEF     -30 // erro no definido na manipulao do Clipboard
#define _kERROR_CLIPBOARD_OBJECT    -31 // objeto do Clipboard de tipo no suportado
#define _kERROR_SMART_OPEN_DEVICE   -51 // erro na abertura do dispositivo SMART
#define _kERROR_SMART_VERSION       -52 // erro ou incompatibilidade de verso do controlador SMART
#define _kERROR_SMART_IDENTIFY      -53 // erro na leitura da identificao (geometria) do dispositivo SMART
#define _kERROR_UNKNOWN             -99 // erro desconhecido


// Definio dos caracteres separadores
#define _kARGS_SEP ";"
#define _kLIST_SEP ","

#endif


/*
 * As constantes so seguidas pelos caracteres _k por
 * um nico motivo: usando o UltraEdit, uso uma regra
 * para a colorao da sintaxe que me permite filtrar
 * as constantes iniciadas por _k, de forma que estas
 * tem uma cor nica, que me permite uma visualizao
 * mais rpida e assim, posso rapidamente identificar
 * as constantes definidas por mim.
 *
 */
