// WAPI.LIB
// Biblioteca de funes para uso da API do Windows
// ------------------------------------------------
//                      Abril/2010, Paulo Buzinello
//                         http://buzinello.com/prg
//                              paulo@buzinello.com
//                                      Londrina/PR
// ------------------------------------------------
//
#include "macros.ch"
#include "wapi.h"


//**************************************************************************************************
function GetTrayInfo() // Retorno:
                       // Uma matriz onde cada elemento ser uma matriz, que conter apenas quatro
                       // valores: o handle da aplicao proprietria do cone, nome/caminho do EXE
                       // da aplicao, seu ttulo e um valor lgico: TRUE, no caso do cone estar
                       // oculto no tray, e FALSE, no caso contrrio.
                       // Na eventualidade de ocorrer um erro, a matriz de retorno estar vazia.
             
local cBuff
local cLine
local cFile := UniqFName(WAPITmpDir())
local aRet  := {}
local aTmp
local i
local s

WAPIError(_kERROR_NONE)
RunWAPICmd("-GETSYSTEMTRAYINFO:"+cFile)

if ReadRetFile(cFile,@cBuff)
   while (i := At(_kEOL,cBuff)) > 0
      cLine := Left(cBuff,i-1)
      cBuff := SubStr(cBuff,i+2)
      *
      aTmp := {}
      for i := 1 to 3
          s := At(",",cLine)
          AAdd(aTmp,if(i=1, Val(Left(cLine,s-1)), Left(cLine,s-1))) // i=1 -> handle; retorna como tipo numrico
          cLine := SubStr(cLine,s+1)
      end
      AAdd(aTmp,cLine=="T")
      AAdd(aRet,aTmp)
   end
end
return aRet
