// WAPI.LIB
// Biblioteca de funes para uso da API do Windows
// ------------------------------------------------
//                    Janeiro/2007, Paulo Buzinello
//                         http://buzinello.com/prg
//                              paulo@buzinello.com
//                                      Londrina/PR
// ------------------------------------------------
//
#include "macros.ch"
#include "wapi.h"


//**************************************************************************************************
function GetHDInfo() // Retorno: uma matriz com trs elementos: cdigo do modlo, nmero de srie de
                     // fbrica e a verso do firmware do primeiro HD da mquina. Se ocorrer um erro
                     // no processo de leitura, a matriz de retorno estar vazia.
local cBuff
local cLine
local cFile := UniqFName(WAPITmpDir())
local aRet  := {}
local i

WAPIError(_kERROR_NONE)
RunWAPICmd("-GETHDINFO:"+cFile)

if ReadRetFile(cFile,@cBuff)
   cLine := Left(cBuff,At(_kEOL,cBuff)-1)
   if Val(cLine) != _kERROR_NONE
      WAPIError(Val(cLine))
      return aRet
   end
   *   
   cLine := SubStr(cBuff,At(_kEOL,cBuff)+2)
   while (i := At(",",cLine)) > 0
      AAdd(aRet,Left(cLine,i-1))
      cLine := SubStr(cLine,i+1)
   end
end
return aRet
