// WAPI.LIB
// Biblioteca de funes para uso da API do Windows
// ------------------------------------------------
//                    Janeiro/2007, Paulo Buzinello
//                         http://buzinello.com/prg
//                              paulo@buzinello.com
//                                      Londrina/PR
// ------------------------------------------------
//
#include "macros.ch"
#include "wapi.h"


//**************************************************************************************************
function DLoadFile(cURL ,; // URL completa do arquivo a ser baixado
                   cVar ,; // varivel (passada por referncia) que receber o contedo
                   cFile,; // arquivo destino (com ou sem path) que armazenar o download
                   nTime ; // opcional: tempo (sec) de tolerncia  falta de trfego (default: 2)
                   )       // ----------------------------------------------------------------------
                           // OBS1: O retorno da funo ser um valor lgico indicativo do resultado
                           //       da operao de download. Sendo TRUE, o contedo do arquivo fonte
                           //       estar armazenado na varivel cVar. Ou, caso cFile tenha um nome
                           //       de arquivo, este armazenar o download.
                           // OBS2: O valor de nTime, se informado, no dever ser elevado, j que o
                           //       tempo de espera, se excessivamente prolongado, poder forar uma
                           //       volta do WAPI sem erro algum no arquivo de resultado.  evidente
                           //       que, se o arquivo alvo no tiver sido baixado (0 bytes) a funo
                           //       retornar FALSE. Mas uma paralizao do trfego poder acontecer
                           //       depois de parte do arquivo ter chegado, o que faria a funo dar
                           //       um falso positivo.
local cBuffer
local cResultFile := UniqFName(WAPITmpDir())
local cTargetFile := UniqFName(WAPITmpDir())
local nHandle
local nSize
local lRet

default nTime to 2

if cFile != _kVOID
   cTargetFile := cFile
else
   if cVar = _kVOID
      WAPIError(_kERROR_PARAMETERS)
      return _kFALSE
   end
end

WAPIError(_kERROR_NONE)
RunWAPICmd("-URL2FILE:"+Quote(cURL       )+_kARGS_SEP+;
                        Quote(cTargetFile)+_kARGS_SEP+;
                        Quote(Str(nTime) )+_kARGS_SEP+;
                        Quote(cResultFile)            )

if !ReadRetFile(cResultFile,@cBuffer)
   return _kFALSE
end
//
// Qualquer erro forar um retorno FALSE, e isso no 
// significa necessariamente uma conexo inexistente.
lRet := Val(cBuffer) = _kERROR_NONE

if lRet
   if File(cTargetFile)
      if cFile = _kVOID
         if (nHandle := FOpen(cTargetFile)) > 0
             nSize   := FSeek(nHandle,0,2)  ; FSeek(nHandle,0,0)
             cVar    := Space(nSize)
             FRead(nHandle,@cVar,nSize)
             FClose(nHandle)
             FErase(cTargetFile)
         else
            WAPIError(_kERROR_UNKNOWN)
            lRet := _kFALSE
         end
      end
   else
      WAPIError(_kERROR_UNKNOWN)
      lRet := _kFALSE
   end
end
return lRet
