// WAPI.LIB
// Biblioteca de funes para uso da API do Windows
// ------------------------------------------------
//                    Janeiro/2007, Paulo Buzinello
//                         http://buzinello.com/prg
//                              paulo@buzinello.com
//                                      Londrina/PR
// ------------------------------------------------
//
#include "macros.ch"
#include "wapi.h"


//**************************************************************************************************
function IsInternet(nTime,; // opcional,  o tempo (segundos) de espera por um retorno (default: 2)
                    cURL  ; // opcional,  uma URL de teste
                    )       // ---------------------------------------------------------------------
                            // OBS: O teste da existncia de uma conexo com a Internet  feito pelo
                            //      download de um arquivo. No caso de no ser informada nenhuma URL
                            //      de teste, ser utilizada uma pgina inexistente do Google, a fim
                            //      de obter como retorno uma outra pgina de erro "404", que sempre
                            //       pequena (+/-1KB). E como  mais fcil o inferno esfriar do que
                            //      o servidor do Google ficar down,  certo que essa pgina vir se
                            //      houver conexo.
                            //      Como a finalidade  apenas testar se existe conexo,  bvio que
                            //      quanto menor for o arquivo alvo, tanto mais rpido ser o teste.
                            //
                            //      FALSOS NEGATIVO E POSITIVO
                            //      ----------------------------------------------------------------
                            //      Qualquer que seja o erro devolvido, a funo sempre retornar um
                            //      valor FALSE. Isso no significa necessariamente que no existe a
                            //      conexo. Caso a URL informada contenha algum erro, evidentemente
                            //      nenhum arquivo ser baixado.
                            //      Na contra-partida, se o tempo limite for definido num valor alto
                            //      demais, e no houver conexo, o WAPI poder retornar sem erro, o
                            //      que far a funo retornar TRUE. Isso  caracterstica da API, e
                            //      no pode ser contornada.
local cBuffer
local cTargetFile := UniqFName(WAPITmpDir())
local cResultFile := UniqFName(WAPITmpDir())
local lRet

default nTime to 2
default cURL  to "www.google.com/maligno.html"

WAPIError(_kERROR_NONE)
RunWAPICmd("-URL2FILE:"+Quote(cURL       )+_kARGS_SEP+;
                        Quote(cTargetFile)+_kARGS_SEP+;
                        Quote(Str(nTime) )+_kARGS_SEP+;
                        Quote(cResultFile)            )

if !ReadRetFile(cResultFile,@cBuffer)
   return _kFALSE
end
//
// Qualquer erro forar um retorno FALSE, e isso no 
// significa necessariamente que no existe conexo.
lRet := Val(cBuffer) = _kERROR_NONE

if lRet
   if File(cTargetFile)
      FErase(cTargetFile)
   else
      WAPIError(_kERROR_UNKNOWN)
      lRet := _kFALSE
   end
end
return lRet
