// WAPI.LIB
// Biblioteca de funes para uso da API do Windows
// ------------------------------------------------
//                    Janeiro/2007, Paulo Buzinello
//                         http://buzinello.com/prg
//                              paulo@buzinello.com
//                                      Londrina/PR
// ------------------------------------------------
//
#include "macros.ch"
#include "wapi.h"


//**************************************************************************************************
function SetWinClip(cData) // string ou nome do arquivo, cujo contedo ser copiado para o clipboard
                           // ----------------------------------------------------------------------
                           // OBS1: se o dado for o nome do arquivo que contm o texto a copiar, seu
                           //       nome dever ser prefixado por "%F:", para que o WAPI possa saber
                           //       que dever carregar um texto arquivado.
                           // OBS2: se cData for um texto numa string, esta poder poder conter uma
                           //       ou vrias linhas quebradas pelo par CR/LF que, neste caso, sero
                           //       trocadas automaticamente para o par "@@". Logo, certifique-se de
                           //       que sua string no conter esse par de caracteres, pois quando o
                           //       WAPI encontr-los, sero convertidos para CR/LF.
local cBuff
local cFile := UniqFName(WAPITmpDir())
local cType := "TXT"
local i

if At(_kEOL,cData) > 0
   cData := StrTran(cData,_kEOL,"@@")
end

WAPIError(_kERROR_NONE)
RunWAPICmd("-SETCLIPBOARD:"+Quote(cType)+_kARGS_SEP+;
                            Quote(cData)+_kARGS_SEP+;
                            Quote(cFile)            )

if !ReadRetFile(cFile,@cBuff)
   return _kFALSE
end

nRet := Val(cBuff)
WAPIError(nRet)
return (nRet=_kERROR_NONE)
