// WAPI.LIB
// Biblioteca de funes para uso da API do Windows
// ------------------------------------------------
//                    Janeiro/2007, Paulo Buzinello
//                         http://buzinello.com/prg
//                              paulo@buzinello.com
//                                      Londrina/PR
// ------------------------------------------------
#include "wapi.h"


//**************************************************************************************************
function GetSysInfo() // Retorna uma matriz com 14 elementos que contm informaes sobre o sistema.
                      // A lista, que ter seus tens separados por vrgulas, contm:
                      //
                      //  1) Nome do computador
                      //  2) Nome do usurio logado no sistema
                      //  3) Diretrio de instalao do Windows (nome longo)
                      //  4) Idem, nome curto
                      //  5) Diretrio do sistema (nome longo)
                      //  6) Idem, nome curto
                      //  7) Diretrio de instalao de programas (nome longo)
                      //  8) Idem, nome curto
                      //  9) Diretrio do desktop do usurio (nome longo) - em branco, se Windows 98
                      // 10) Idem, nome curto
                      // 11) Diretrio do desktop para todos os usurios (nome longo)
                      // 12) Idem, nome curto
                      // 13) Diretrio da pasta "Meus Documentos" (nome longo)
                      // 14) Idem, nome curto
local cBuff
local cItem
local cFile := UniqFName(WAPITmpDir())
local aRet  := {}
local i

WAPIError(_kERROR_NONE)
RunWAPICmd("-GETSYSTEMINFO:"+cFile)

if ReadRetFile(cFile,@cBuff)
   while (i := At(",",cBuff)) > 0
      cItem := Left(cBuff,i-1)
      cBuff := SubStr(cBuff,i+1)
      AAdd(aRet,AllTrim(cItem))
   end
   AAdd(aRet,AllTrim(cBuff))
end
return aRet
