// WAPI.LIB
// Biblioteca de funes para uso da API do Windows
// ------------------------------------------------
//                    Janeiro/2007, Paulo Buzinello
//                         http://buzinello.com/prg
//                              paulo@buzinello.com
//                                      Londrina/PR
// ------------------------------------------------
//
#include "macros.ch"
#include "wapi.h"


//**************************************************************************************************
function GetPrinters() // Retorno: matriz com matrizes de trs elementos: valor lgico que, se TRUE,
                       // indicar que se trata da impressora default, string do nome da impressora,
                       // e string com o nome da porta a qual a impressora est ligada.
local cBuff            // Na ocorrncia de algum erro, ser devolvida uma matriz vazia.
local cLine
local cFile := UniqFName(WAPITmpDir())
local aRet  := {}
local i

WAPIError(_kERROR_NONE)
RunWAPICmd("-GETPRINTERS:"+cFile)

if ReadRetFile(cFile,@cBuff)
   if Left(cBuff,1) = "?"
      WAPIError(_kERROR_UNKNOWN)
      return aRet
   end
   
   while (i := At(_kEOL,cBuff)) > 0
      cLine := Left(cBuff,i-1)
      cBuff := SubStr(cBuff,i+2)
      //
      // Separao dos dados da impressora
      i := RAt(",",cLine)                // obter a posio do separador das strings do nome e porta
      AAdd(aRet,{Left(cLine,1)="1"    ,; // as posies 1 e 2 de cBuff so conhecidas e fixas
      	         SubStr(cLine,3,i-1-2),; // nome e...
      	         SubStr(cLine,i+1)    }) // porta da impressora identificada nesta linha
   end
end
return aRet
