// WAPI.LIB
// Biblioteca de funes para uso da API do Windows
// ------------------------------------------------
//                    Janeiro/2008, Paulo Buzinello
//                         http://buzinello.com/prg
//                              paulo@buzinello.com
//                                      Londrina/PR
// ------------------------------------------------
//
#include "macros.ch"
#include "wapi.h"


//**************************************************************************************************
function PrintFile(cPrtName ,; // nome (ou porta) da impressora (# para a impressora default)
                   cRptFile ,; // arquivo (com/sem path) cujo contedo ser enfileirado no spooler
                   cRptTitle,; // ttulo do relatrio (default: string fixa com data e hora)
                   lPaged   ,; // se TRUE (default: FALSE), cada pgina  iniciada por uma tag
                   cPages   ,; // lista das pginas a imprimir (default: string vazia, para todas)
                   lPrintAll,; // se TRUE (default), forar a impresso de todas as pginas
                   lEven    ,; // se TRUE (default: FALSE), imprimir apenas as pginas pares
                   lOdd     ,; // se TRUE (default: FALSE), imprimir apenas as pginas mpares
                   lReverse ,; // flag para imprimir as pginas em ordem inversa (default: FALSE)
                   nCount   ,; // quantidade de cpias a imprimir (default: 1)
                   lGroup    ; // flag para agrupamento de pginas, se nCount > 1 (default: TRUE)
                   )           // ------------------------------------------------------------------
                               // OBS1: Se lPaged for TRUE, cada pgina ter de ser iniciada com uma
                               //       tag identificadora, de cdigo fixo Chr(2)+Chr(11)+Chr(3). Se
                               //       esse flag for FALSE, todos os parmetros informados aps ele
                               //       sero ignorados, a exceo de nCount.
                               // OBS2: Se cPages contiver uma lista vazia e lEven ou lOdd for TRUE,
                               //       todas as pginas sero impressas de acordo com esse filtro.
                               // OBS3: O flag lPrintAll sempre ser TRUE se lEven e Odd forem FALSE
                               //       e a lista de pginas estiver vazia.
                               // OBS4: O flag lGroup s ter efeito prtico se nCount for maior que
                               //       1. Neste caso, se este for FALSE, as pginas sero impressas
                               //       com seus nmeros iguais contguos. Exemplo: "1,1,2,2,3,3,...

local cFile := UniqFName(WAPITmpDir())
local cBuff
local nRet

WAPIError(_kERROR_NONE)

if cPrtName=_kVOID .or. cRptFile=_kVOID .or. !File(cRptFile)
   WAPIError(_kERROR_PARAMETERS)
   return _kFALSE
end

default cRptTitle to "clipper.report@"+DtoC(Date())+","+Time()
default lPaged    to _kFALSE
default cPages    to ""
default lPrintAll to _kTRUE
default lEven     to _kFALSE
default lOdd      to _kFALSE
default lReverse  to _kFALSE
default nCount    to 1
default lGroup    to _kTRUE

if lPrintAll
   cPages := "A"
else
   if lEven
      cPages := "E" + if(Empty(cPages),"",","+cPages)
   else
      if lOdd
         cPages := "O" + if(Empty(cPages),"",","+cPages)
      end
   end
end

RunWAPICmd("-PRINT:"+Quote(     cPrtName           )+_kARGS_SEP+;
                     Quote(     cRptFile           )+_kARGS_SEP+;
                     Quote(     cRptTitle          )+_kARGS_SEP+;
                     Quote(  if(lPaged  , "T", "F"))+_kARGS_SEP+;
                     Quote(     cPages             )+_kARGS_SEP+;
                     Quote(  if(lReverse, "T", "F"))+_kARGS_SEP+;
                     Quote(TStr(nCount)            )+_kARGS_SEP+;
                     Quote(  if(lGroup  , "T", "F"))+_kARGS_SEP+;
                     Quote(     cFile              )            )

if !ReadRetFile(cFile,@cBuff)
   return _kFALSE
end

nRet := Val(cBuff)
WAPIError(nRet)
return (nRet=_kERROR_NONE)
