// WAPI.LIB
// Biblioteca de funes para uso da API do Windows
// ------------------------------------------------
//                    Janeiro/2007, Paulo Buzinello
//                         http://buzinello.com/prg
//                              paulo@buzinello.com
//                                      Londrina/PR
// ------------------------------------------------
//
#include "macros.ch"
#include "wapi.h"


//**************************************************************************************************
function WriteWReg(cKeyPath ,; // caminho da chave, semelhante  rvore de diretrios
                   cEntry   ,; // nome da entrada que receber o valor
                   cDataType,; // tipo: B (binrio), C (caractere), N (numrico) ou T (texto)
                   xData     ; // varivel que conter o dado a ser gravado
                   )           // ------------------------------------------------------------------
                               // OBS1: Se o dado for do tipo binrio, xData poder ser informado de
                               //       duas formas: uma string contendo a lista de nmeros (string)
                               //       entre 0 e 255 (byte), separados por vrgulas ou, uma simples
                               //       matriz em que cada elemento conter um nmero.
                               // OBS2: Se o tipo for texto com mltiplas linhas (T), h duas formas
                               //       de informar o dado: um texto comum, com linhas separadas por
                               //       um par CR/LF (13/10) ou atravs de um arquivo externo. Neste
                               //       caso, o nome do arquivo dever ter o prefixo especial "%F:".
                               // OBS3: O tipo texto (T) no  suportado pelo Windows 95/98/Me.

local cFile := UniqFName(WAPITmpDir())
local cBuff
local cList
local nRet

WAPIError(_kERROR_NONE)

if !cDataType $ "BCNT" .or. !ValType(xData) $ "ACN"
   WAPIError(_kERROR_PARAMETERS)
   return _kFALSE
end

if     cDataType = "B"
       if ValType(xData) = "A"
          if AScan(xData,{|b|ValType(b) != "N" .or. b < 0 .or. b > 255}) > 0
             WAPIError(_kERROR_PARAMETERS)
             return _kFALSE
          end
          cList := ""
          AEval(xData,{|b,i|cList += TStr(b)+if(i=Len(xData),"",",")})
          xData := cList
       end
       *
elseif cDataType = "N"
       xData = TStr(xData)
       *
elseif cDataType = "T"
       if Upper(Left(xData,3)) = "%F:"
          if !File(SubStr(xData,4))
             WAPIError(_kERROR_PARAMETERS)
             return _kFALSE
          end
       else
          xData := StrTran(xData,_kEOL,"@@")
       end
end

RunWAPICmd("-WRITEREGISTRY:"+Quote(cKeyPath )+_kARGS_SEP+;
                             Quote(cEntry   )+_kARGS_SEP+;
                             Quote(cDataType)+_kARGS_SEP+;
                             Quote(xData    )+_kARGS_SEP+;
                             Quote(cFile    )            )

if !ReadRetFile(cFile,@cBuff)
   return _kFALSE
end

nRet := Val(cBuff)
WAPIError(nRet)
return (nRet=_kERROR_NONE)
