// WAPI.LIB
// Biblioteca de funes para uso da API do Windows
// ------------------------------------------------
//                    Janeiro/2007, Paulo Buzinello
//                         http://buzinello.com/prg
//                              paulo@buzinello.com
//                                      Londrina/PR
// ------------------------------------------------
//
#include "macros.ch"

#define _kMAX_COMMAND_LINE_SIZE 64


//**************************************************************************************************
function RunWAPICmd(cCommand)
local nCursor := SetCursor(0)
local bError  := ErrorBlock({|o|Break(o)})
local cWAPI   := DirOrigin()+"\WAPI.EXE"
local nSecs
local cFile
local nFHdl
local lRet
*
//
// Devido a uma limitao, ou da funo SwpRunCmd() ou da NTVDM (NT), se a linha de comando for
// excessivamente longa, esta poder ser truncada. Desta forma, ao atingir o tamanho limite ela
// ser informada atravs de um arquivo texto adicional.
if Len(cCommand) > _kMAX_COMMAND_LINE_SIZE
   cFile := UniqFName(WAPITmpDir())
   nFHdl := FCreate(cFile)
   if nFHdl = -1
      WAPIError(_kERROR_PARAMETERS_FILE)
      return _kFALSE
   end
   FWrite(nFHdl,cCommand)
   FClose(nFHdl)
   cCommand := cWAPI+" -PARMSFILE:"+Quote(cFile)
else
   cCommand := cWAPI+" "+cCommand
end
//
// Se o linker utilizado na montagem do programa no for o BLinker, automaticamente
// ser utilizado o comando RUN. Neste caso, o retorno da funo ser sempre TRUE.
begin sequence
    lRet := SwpRunCmd(cCommand,0,,WAPITmpDir())
recover
    run (cCommand)
    lRet := _kTRUE
end
ErrorBlock(bError)
SetCursor(nCursor)
//
// Apagamento do arquivo de transporte dos argumentos, se for o caso.
if cFile != _kVOID
   FErase(cFile)
end
return lRet
