// WAPI.LIB
// Biblioteca de funes para uso da API do Windows
// ------------------------------------------------
//                    Janeiro/2007, Paulo Buzinello
//                         http://buzinello.com/prg
//                              paulo@buzinello.com
//                                      Londrina/PR
// ------------------------------------------------
//
#include "macros.ch"
#include "wapi.h"


//**************************************************************************************************
function ReadRetFile(cFile  ,; // nome do arquivo de resultado
                     cBuffer ; // esta varivel dever ser passada por referncia
                     )         // ------------------------------------------------------------------
                               // OBS: O retorno ser TRUE caso a operao seja bem sucedida. Aps a
                               //      leitura, o arquivo ser apagado.
local nSecs := Seconds()
local nSize
local nHandle

cBuffer := ""
while !File(cFile)
   if WAPITimeOut() > 0 .and. Seconds()-nSecs >= WAPITimeOut()
      WAPIError(_kERROR_TIMEOUT)
      return _kFALSE
   end
end

nSecs := Seconds()
while (nHandle := FOpen(cFile)) = -1
   if WAPITimeOut() > 0 .and. Seconds()-nSecs >= WAPITimeOut()
	    WAPIError(_kERROR_OPEN_RESULTFILE)
      FErase(cFile)
      return _kFALSE
   end
end

nSize   := FSeek(nHandle,0,2) ; FSeek(nHandle,0,0)
cBuffer := Space(nSize)
FRead(nHandle,@cBuffer,nSize)
FClose(nHandle)
FErase(cFile)

if Len(cBuffer) = 0
   WAPIError(_kERROR_READ_RESULTFILE)
   return _kFALSE
end

return _kTRUE
