#define _kWAPI_VERSION "1.05"

/*
 * WAPI.C (funes da API do Windows para DOS)
 * -------------------------------------------
 *                 Abril/2007, Paulo Buzinello
 *          Home: http://www.buzinello.com/prg
 *                         paulo@buzinello.com
 *                                 Londrina/PR
 *                                      Brasil
 * -------------------------------------------
 * Licena de uso:
 * A utilizao deste software e da biblioteca
 * que o acompanha  totalmente livre e grtis
 * em quaisquer circunstncias. Sinta-se livre
 * para promover modificaes no todo ou parte
 * dos fontes, da maneira que quiser. Sinta-se
 * livre tambm para distribuir este software,
 * desde que integral e gratuitamente, e dando
 * os devidos crditos ao autor original e aos
 * autores das modificaes subseqentes.
 * -------------------------------------------
 * Responsabilidade:
 * O autor se isenta integralmente de qualquer
 * responsabilidade sobre prejuzos que possam
 * ser causados pelo mau uso e mesmo por algum
 * possvel erro de programao ou de projeto.
 * -------------------------------------------
 *
 * Compilador GCC:
 *            gcc wapi.c -s -c -Os
 *            gcc wapi.o -s -mwindows -mconsole -l wininet -l winspool -l winmm -owapi.exe
 * -------------------------------------------------------------------------------------------------
 *
 * Sintaxe.: WAPI <switch1>:args1 [<switch2>:args2 [...]]
 *
 * OBS1....: Os argumentos devero estar separados por ponto-e-vrgula (;).
 *
 * OBS2....: Os nomes de arquivos, impressoras, ttulos de documentos, etc (tudo que contm espaos)
 *           devero estar entre aspas, sendo tambm "case-insensitive".
 *
 * OBS3....: Os nomes de arquivos podero conter o caminho completo do arquivo ou apenas seu nome. E
 *           sendo apenas o nome, ser utilizado o diretrio default, para leitura e escrita. Mas se
 *           no quiser criar um arquivo de resultado, troque seu nome por NUL.
 *
 * OBS4....: Se executado atravs de um programa Clipper,  possvel que a linha de comando se torne
 *           excessivamente extensa, a ponto de no ser repassada integralmente ao WAPI. Neste caso,
 *           h uma alternativa: utilizar um arquivo texto adicional que conter os argumentos, como
 *           se fosse a prpria linha de comando. Veja o switch -PARMSFILE.
 *
 * OBS5....: Alguns switches criam um arquivo de resultado onde poder constar um cdigo numrico de
 *           resultado da operao. O cdigo de sucesso  zero. Os demais cdigos podero ser vistos
 *           no arquivo de cabealho "wapi.h".
 * -------------------------------------------------------------------------------------------------
 *
 * Switches: No esquea que cada switch  prefixado por um hfen. ;-)
 *
 *          -PARMSFILE:<fileName>
 *           Obriga o WAPI a ler os parmetros de execuo contidos no arquivo <fileName>, que sero
 *           executados seqencialmente.
 *           OBS1: Os switches devero ser informados no arquivo da mesma forma como seriam na linha
 *                 de comando, separados por espaos. Alternativamente, um em cada linha.
 *           OBS2: Uma vez que o contedo do arquivo seja processado, a leitura (e interpretao) da
 *                 linha de comando continuar normalmente, permitindo, portando, processar das duas
 *                 formas. Exemplo: "WAPI -ParmsFile:parms.txt -flash:5" far o WAPI executar todo o
 *                 contedo do arquivo "parms.txt" e em seguida, far o ttulo da aplicao piscar.
 *
 *          -DELETEREGISTRY:<fullKeyPath>;<entryName>;<resultFile>
 *           Apaga a entrada <entryName> da chave do Registry informada em <fullKeyPath>, gravando o
 *           resultado da operao no arquivo informado em <resultFile>.
 *           OBS1: Se quiser apagar uma chave especfica e todas as suas entradas, informe apenas um
 *                 asterisco (*) no lugar de <entryName>.
 *           OBS2: A identificao do caminho da chave deve ser completa, comeando da raiz, como se
 *                 fosse um diretrio. Exemplo:
 *                 HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Run.
 *           OBS3: Ao invs de utilizar o nome completo da chave primria (raiz), que  extenso, seu
 *                 nome poder ser trocado por um acrnimo, conforme a tabela abaixo.
 *                       HKEY_CLASSES_ROOT   = HKCR
 *                       HKEY_CURRENT_USER   = HKCU
 *                       HKEY_LOCAL_MACHINE  = HKLM
 *                       HKEY_USERS          = HKU
 *                       HKEY_CURRENT_CONFIG = HKCC
 *           OBS4: Os nomes (<fullKeyPath> e <entryName) so "case insensitive".
 *           OBS5: O uso deste comando pode requerer direitos de administrador em verses do Windows
 *                 que exercem controle sobre os privilgios de acesso de usurios.
 *
 *          -FLASH:<times>[;<handle>]
 *           Faz piscar <times> vezes o boto da taskbar e a barra de ttulo da janela atualmente em
 *           foco ou, opcionalmente, da janela cujo <handle> for informado.
 *
 *          -GETAPPSINFO:<resultFile>
 *           Cria e carrega o arquivo <resultFile> com a lista de todas as aplicaes "top level" do
 *           Windows, sendo que cada aplicao ocupar uma linha da lista e para cada aplicao ser
 *           informado seu handle e ttulo.
 *
 *          -GETCLIPBOARD:<resultFile>
 *           Cria e carrega o arquivo <resultFile> com o contedo atualmente armazenado no Clipboard
 *           do Windows. O arquivo sempre conter na primeira linha o cdigo indicativo do resultado
 *           da operao. Normalmente ser o cdigo de sucesso ou de objeto no suportado. A segunda
 *           linha conter uma string que representa o tipo do objeto recuperado: por enquanto, como
 *           apenas textos so suportados, esta string ser sempre "TXT". A partir da terceira linha
 *           estar o contedo recuperado.
 *
 *          -GETDEFPRINTER:<resultFile>
 *           Cria e carrega o arquivo <resultFile> com o nome da impressora padro e da porta a qual
 *           ela est conectada, separados por vrgula.
 *
 *          -GETHDINFO:<resultFile>
 *           Grava no arquivo <resultFile> os dados do disco principal da mquina: modlo, nmero de
 *           srie e verso do firmware (separados por vrgula).
 *           OBS: Esses dados existem apenas nos modlos mais novos de disco, aderentes  tecnologia
 *                S.M.A.R.T. (Self Monitoring Analysis and Reporting Technology) e em mquinas cujas
 *                motherboards contenham firmware compatvel. O sistema operacional tambm precisar
 *                suportar a tecnologia. No Windows XP ela  nativa. Nas verses mais antigas poder
 *                ser necessrio instalar um upgrade.
 *
 *          -GETMYHANDLE:<resultFile>
 *           Cria e carrega arquivo <resultFile> com o handle da janela atual.
 *
 *          -GETPRINTERS:<resultFile>
 *           Cria e carrega o arquivo <resultFile> com a lista das impressoras instaladas no Windows
 *           (uma por linha). Para cada impressora haver trs informaes (separadas por vrgulas):
 *           um nmero indicando se  a impressora default (1) ou no (0), o nome desta impressora e
 *           a porta a qual ela est conectada.
 *
 *          -GETSYSTEMINFO:<resultFile>
 *           Cria e carrega o arquivo <resultFile> com algumas informaes sobre o sistema. Os dados
 *           listados, por ordem de gravao:
 *                       1) Nome do computador
 *                       2) Nome do usurio logado no sistema
 *                       3) Diretrio de instalao do Windows (nome longo)
 *                       4) Idem, nome curto
 *                       5) Diretrio do sistema (nome longo)
 *                       6) Idem, nome curto
 *                       7) Diretrio de instalao de programas (nome longo)
 *                       8) Idem, nome curto
 *                       9) Diretrio do desktop do usurio (nome longo)
 *                      10) Idem, nome curto
 *                      11) Diretrio do desktop para todos os usurios (nome longo)
 *                      12) Idem, nome curto
 *                      13) Diretrio da pasta "Meus Documentos" (nome longo)
 *                      14) Idem, nome curto
 *
 *           OBS: Os tens 9 e 10 no existem para verses no NT do Windows.
 *
 *          -GETWAPIVERSION:<resultFile>
 *           Informa no arquivo <resultFile> a verso dos fontes do programa.
 *
 *          -GETSYSTEMTRAYINFO:<resultFile>
 *           Cria e carrega o arquivo <resultFile> com a lista dos cones residentes no "tray". Cada
 *           um ocupar uma linha da lista, sendo informado, na ordem: "handle" da aplicao (com ou
 *           sem janela) proprietria do cone, o nome/caminho do executvel, o nome da janela (se o
 *           cone tiver uma) e uma letra indicativa de um valor lgico: "T", se o cone se encontra
 *           no "tray" ou "F", se estiver visvel.
 *           OBS1: Alguns cones, normalmente invisveis, seriam relacionados em duplicidade, mas se
 *                 aparecem com o mesmo "handle", tm o mesmo "owner". Logo, no faro falta. Assim,
 *                 eles so eliminados da lista de retorno.
 *           OBS2: O nome do executvel  obtido atravs do seu nome de dispositivo. Exemplo de nome
 *                 obtido: "\Device\HarddiskVolume0", que corresponde ao drive C:. Por isso,  feita
 *                 a troca para a letra do drive. Assim, caso aparea uma letra como "?:", significa
 *                 que o nome do dispositivo, por alguma razo, no foi encontrado.
 *
 *          -GETWINDOWSINFO:<resultFile>
 *           Cria e carrega o arquivo <resultFile> com diversos dados acerca da verso do Windows em
 *           execuo. A lista informada conter os seguintes tens (separados por vrgulas): cdigo
 *           da plataforma ("NT" para kernel NT, "9X" para Windows 95/98/Me, ou "W32S" para a verso
 *           3.x), string de identificao completa da verso, o service pack instalado e uma string
 *           com o numrico da verso.
 *
 *          -HIBERNATE
 *           Coloca o Windows em estado de hibernao.
 *
 *          -KILLAPPLICATION:<handle>[;<fileName>]
 *           Provocar o encerramento da aplicao vinculada ao <handle> informado ou, se informado o
 *           <fileName>, sero fechadas todas as aplicaes originadas deste executvel.
 *           OBS1: Se informado, <fileName> poder ser um nome completo ou parcial, sempre sem path.
 *           OBS2: Os argumentos so exclusivos. Ou seja, se existir o argumento <fileName> ele ser
 *                 o nico a ser utilizado, mesmo que tambm seja informado o <handle>. E neste caso
 *                 o valor de <handle>, se existir, ser desconsiderado.
 *           OBS3: A(s) aplicao(es) ser(o) fechada(s) imediatamente, sem qualquer tipo de aviso
 *                 ou espera. Ou seja, quaisquer dados, ainda pendentes de gravao, sero perdidos.
 *
 *          -PLAYWAVE:<source>
 *           Reproduz um arquivo de som (.WAV), o som relacionado a um evento configurado do Windows
 *           (configurado pelo Painel de Controle) ou mesmo o som relacionado a um evento do usurio
 *           (configurado pelo Registry). Ser considerado um evento o nome em <source> que no seja
 *           posfixado com a extenso ".WAV". Caso <source> seja um arquivo invlido ou mesmo o nome
 *           de um evento inexistente a funo falhar silenciosamente, sem qualquer aviso.
 *           OBS: Nomes de eventos comuns no Windows XP, que podem ser pesquisados no Registry sob a
 *                chave "HKEY_CURRENT_USER\AppEventos\EventLabels":
 *                      "DeviceConnect"
 *                      "DeviceDisconnect"
 *                      "DeviceFail"
 *                      "EmptyRecycleBin"
 *                      "LowBatteryAlarm"
 *                      "MailBeep"
 *                      "MenuCommand"
 *                      "MenuPopup"
 *                      "SystemAsterisk"
 *                      "SystemExclamation"
 *                      "SystemExit"
 *                      "SystemHand"
 *                      "SystemNotification"
 *                      "SystemQuestion"
 *                      "SystemStart"
 *                      "WindowsLogon"
 *                      "WindowsLogoff"
 *                      ".Default"
 *
 *          -POWEROFF
 *           Desliga o Windows (se a opo for suportada pelo hardware).
 *
 *          -PRINT:<printer>;<report>;<title>;<paged>;<pages>;<reverse>;<count>;<group>;<resultFile>
 *           Enfileira o contedo do arquivo <report> no spooler do Windows, como uma nova tarefa de
 *           impresso sob o ttulo <title>, para que seja impresso pela impressora <printer>, total
 *           ou parcialmente. Se o modo <paged> for verdadeiro ("T"), significa que as pginas foram
 *           identificadas atravs de marcadores especiais (vide OBS4). Isso torna possvel imprimir
 *           de vrias formas diferentes: parcialmente e/ou reversa e/ou agrupada. Se este argumento
 *           for falso ("F"), tais recursos especiais no estaro mais disponveis. No caso de haver
 *           essa marcao de pginas, o parmetro <pages> dever receber um de dois tipos de dados:
 *           uma simples letra "A" para imprimir todas as pginas (caracteres extras so proibidos),
 *           ou uma lista simples com os nmeros (separados por vrgula) das pginas que devero ser
 *           impressas. Exemplo: "1,2,10,15". Opcionalmente, um comando especial de filtragem poder
 *           figurar como primeiro tem da lista (sempre nessa posio). Se precisar imprimir apenas
 *           as pginas pares, informe a letra "E" (even). Para imprimir as pginas mpares, a letra
 *           "O" (odd). Sendo necessrio informar uma seqncia de pginas, poder ser utilizada uma
 *           representao reduzida, contendo apenas os nmeros inicial e final, separados por hfen
 *           ("i-f"). Exemplo: "1-5" far imprimir as pginas compreendidas entre 1 e 5 (inclusive).
 *           Um dos dois poder ser omitido. Nunca os dois simultneamente. Caso "i" seja omitido, o
 *           seu valor ser 1 (primeira pgina). Se "f" for omitido, este receber o valor da ltima
 *           pgina existente. O parmetro <reverse>, se informado verdadeiro ("T"), far com que as
 *           pginas sejam impressas em ordem invertida, decrescente. Sendo falso ("F"), a impresso
 *           ser em ordem crescente. O parmetro <count>  a quantidade de repeties da impresso.
 *           O parmetro <group>, que ser relevante apenas se <count> for maior que 1, se for falso
 *           ("F"), imprimir repetidamente as pginas de nmeros iguais. Exemplo: "1,1,2,2,3,3...".
 *           Se o valor for verdadeiro ("T") as pginas sero impressas seqencialmente. O cdigo do
 *           resultado do enfileiramento no spooler ser informado no arquivo <resultFile>.
 *           OBS1: Todos os parmetros so obrigatrios. Inclusive os que sero ignorados em virtude
 *                 de uma configurao que os torne dispensveis. E estes at podero conter valores
 *                 atpicos, apesar disso no ser recomendvel. Exemplo: se <paged> for "F" deduz-se
 *                 que no existem marcadores de pginas. Portanto, <pages> poder receber quaisquer
 *                 valores, mesmo que invlidos. O mesmo vale para <reverse> e <group>.
 *           OBS2: Quando quiser imprimir para a impressora default do sistema, informe um caractere
 *                 sustenido (#) em <printer>.
 *           OBS3: Voc poder enviar a impresso diretamente para uma determinada porta. Para isso,
 *                 informe o nome desta porta em <printer>.
 *           OBS4: Se o sistema tiver de manipular pginas pelos seus nmeros, ser preciso que cada
 *                 incio de pgina esteja marcado com um identificador (ou tag). Isso possibilitar
 *                 encontrar qualquer pgina por seu nmero. Tal identificador  representado por um
 *                 grupo de cdigos ASCII: 02, 11 e 03 (decimal), ou STX+VT+ETX. Evidentemente, tais
 *                 smbolos sero ignorados na impresso.
 *           OBS5: Os dados contidos no arquivo so direcionados para o spooler sem qualquer tipo de
 *                 modificao, exceto os identificadoras de pginas, que sero descartados.
 *           OBS6: O arquivo de resultado conter apenas o cdigo do resultado do enfileiramento dos
 *                 dados no spooler de impresso. Isso no tem relao com o resultado da impresso.
 *
 *          -READREGISTRY:<fullKeyPath>;<entryName>;<resultFile>
 *           Recupera a entrada <entryName> da chave do Registry <fullKeyPath> e armazena o contedo
 *           no arquivo <resultFile>.
 *           OBS1: Se quiser recuperar todas as entradas da chave, informe um asterisco (*) no lugar
 *                 de <entryName>.
 *           OBS2: O arquivo de resultado conter na primeira linha o cdigo de resultado da leitura
 *                 realizada. A partir da segunda linha sero inseridas as informaes. Cada entrada
 *                 ocupar uma linha e cada entrada conter trs informaes: nome, tipo e contedo,
 *                 na forma "<nome>=<tipo>,<contedo>". Se o dado for do tipo caractere ou numrico,
 *                 contedo ser informado diretamente. Mas no caso do tipo binrio, cada valor ser
 *                 terminado por um ponto (.), e o conjunto ser delimitado por um sustenido (#). Se
 *                 o dado for do tipo texto com vrias linhas, cada uma ser terminada por um Ctrl+Z
 *                 (caractere 26).
 *           OBS3: O nome do caminho da chave dever estar completo, comeando pela raiz, e deve ser
 *                 informado como se fosse o nome de um diretrio do disco. Exemplo:
 *                 HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Run.
 *           OBS4: Ao invs de utilizar o nome completo da chave primria (raiz), que  extenso, seu
 *                 nome poder ser trocado por um acrnimo, conforme a tabela abaixo.
 *                       HKEY_CLASSES_ROOT   = HKCR
 *                       HKEY_CURRENT_USER   = HKCU
 *                       HKEY_LOCAL_MACHINE  = HKLM
 *                       HKEY_USERS          = HKU
 *                       HKEY_CURRENT_CONFIG = HKCC
 *           OBS5: O uso deste comando pode requerer direitos de administrador em verses do Windows
 *                 que exercem controle sobre os privilgios de acesso de usurios.
 *
 *          -REBOOT
 *           Reinicia o Windows.
 *
 *          -SCREENSAVER:{GET|SET};{resultFile|{ON|OFF}}
 *           L o estado do screenSaver ou o reconfigura. O primeiro parmetro deve ser a palavra de
 *           definio da tarefa, conforme se queira ler (GET) ou configurar (SET). Se for para ler,
 *           o segundo parmetro ser o nome do arquivo que conter o resultado: 0 (screenSaver est
 *           inativo) ou 1 (ativo). Se a tarefa for de configurao, o segundo parmetro ser o novo
 *           estado: ON para ativar ou OFF para desativar.
 *
 *          -SENDTORECYCLEBIN:<fileName>[,<dirName>[,...]];<resultFile>
 *           Envia para a lixeira do Windows um ou mais arquivos e/ou diretrios, informados atravs
 *           de uma lista simples, com os tens separados por vrgulas. O resultado da operao ser
 *           informado no arquivo <resultFile> como um cdigo numrico.
 *           OBS1: Cada tem da lista, seja arquivo ou diretrio, deve ser totalmente qualificado, o
 *                 que incluir at a letra do drive. Caso o caminho no esteja completo, o tem ser
 *                 apagado de forma convencional, e no ir para a lixeira.
 *           OBS2: Se uma lista contiver mais de um tem e ao menos um deles no existir, a operao
 *                 toda ser ignorada e nenhum tem ser apagado.
 *           OBS3: Caracteres coringas (* e ?), como normalmente se usa em DOS, sero considerados.
 *           OBS4: O encaminhamento de arquivos/diretrios para a lixeira depende da configurao da
 *                 lixeira. Se configurada para no ser utilizada, o apagamento ser definitivo.
 *
 *          -SETAPPTITLE:<title>[;<handle>]
 *           Altera o texto do ttulo da janela em foco para <title>. Opcionalmente, pode-se mudar o
 *           alvo da funo, ao informar o <handle> de uma janela especfica.
 *
 *          -SETBUTTONX:<on|off|del>[;<handle>]
 *           Liga (on) ou desliga (off) o boto X da janela, ou ento remove (del) o tem do menu de
 *           contexto da janela que efetua o fechamento da aplicao (esta operao  irreversvel).
 *           Opcionalmente pode-se informar o <handle> da janela que ser alvo da funo.
 *
 *          -SETCLIPBOARD:<valueType>;<value>;<resultFile>
 *           Grava no Clipboard do Windows o contedo de <value> do tipo informado em <valueType>. O
 *           cdigo numrico do resultado da operao ser informado no arquivo <resultFile>.
 *           OBS1: Por enquanto o nico tipo suportado  texto. Assim, <valueType> dever ser "TXT".
 *           OBS2: O contedo de <value> dever ser uma string simples ou um texto delimitado por um
 *                 par de arrobas (@@) que sero trocadas por pares CR/LF. Se o texto reside num
 *                 arquivo, seu nome poder ser informado prefixado por "%F:" (case insensitive).
 *
 *          -SETSTARTBUTTON:<hide|show|disable|enable>
 *           Torna o boto "iniciar" da taskbar invisvel (hide) ou visvel (show). Ou muda o acesso
 *           a suas funo, tornando-o desabilitado (disable) ou habilitado (enable).
 *           OBS1: Quando desabilitado (ou invisvel), no ser mais possvel acessar o boto usando
 *                 o mouse. Mas as teclas WinKey e Ctrl+ESC continuaro funcionando normalmente.
 *
 *          -SETTASKBUTTON:<hide|show>[;<handle>]
 *           Torna invisvel (hide) ou visvel (show) o boto da aplicao (focalizada) na taskbar e
 *           a prpria janela. Opcionalmente, a operao poder ser efetuada na janela cujo <handle>
 *           for informado.
 *
 *          -SUSPEND
 *           Suspende o Windows.
 *
 *          -URL2FILE:<URL>;<fileName>;<timeOut>;<resultFile>
 *           Faz o download da <URL> da Internet para o arquivo <fileName> e informa o resulta desta
 *           operao no arquivo <resultFile>. O valor <timeOut> se refere ao tempo de espera (secs)
 *           que, ultrapassado, forar o retorno com erro.
 *           OBS1: O nico protocolo aceito  o HTTP, mas o prefixo "http://" no  obrigatrio, mas
 *                 no caso de ser informado ser suprimido. Entretanto, o prefixo "www." ter de ser
 *                 informado, pois o servidor precisa ser identificado e conectado separadamente.
 *           OBS2: O valor de <timeOut>, se elevado demais (ou zero: infinito), poder fazer com que
 *                 ocorra, errneamente, um retorno bem-sucedido. Isso  uma particularidade da API.
 *           OBS3: O arquivo de resultado conter apenas o valor zero, no caso da operao finalizar
 *                 com sucesso, ou um cdigo de erro que, normalmente, ser pelo tempo esgotado.
 *
 *          -WINDOW2TOP:<handle>
 *           Traz para a frente, na lista Z de janelas, a janela cujo <handle> for informado.
 *
 *          -WRITEREGISTRY:<fullKeyPath>;<entryName>;<valueType>;<value>;<resultFile>
 *           Armazena na chave <fullKeyPath> do Registry do Windows o contedo de <value> na entrada
 *           <entryName>. O resultado da operao ser informado no arquivo <resultFile>.
 *           OBS1: Se a chave <fullKeyPath> no existir no todo ou em parte, ser criada.
 *           OBS2: <valueType>  o tipo do dado a gravar, sendo quatro tipos: binrio (B), caractere
 *                 (C), numrico (N) ou texto de mltiplas linhas (T).
 *           OBS3: Caso o tipo seja binrio (B), a lista de nmeros (limitados entre 0 e 255) dever
 *                 ser passada como uma lista com os valores separados por vrgulas.
 *           OBS4: Se o tipo for texto (T) (mltiplas linhas), h duas formas de informar: uma lista
 *                 de strings separadas por um par de arrobas (@@) ou atravs de um arquivo externo,
 *                 cujo nome dever ser prefixado pelo smbolo "%F:" (case insensitive).
 *           OBS5: O nome do caminho da chave dever estar completo, comeando pela raiz, e deve ser
 *                 informado como se fosse o nome de um diretrio do disco. Exemplo:
 *                 HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Run.
 *           OBS6: Ao invs de utilizar o nome completo da chave primria (raiz), que  extenso, seu
 *                 nome poder ser trocado por um acrnimo, conforme a tabela abaixo.
 *                       HKEY_CLASSES_ROOT   = HKCR
 *                       HKEY_CURRENT_USER   = HKCU
 *                       HKEY_LOCAL_MACHINE  = HKLM
 *                       HKEY_USERS          = HKU
 *                       HKEY_CURRENT_CONFIG = HKCC
 *           OBS7: O uso deste comando pode requerer direitos de administrador em verses do Windows
 *                 que exercem controle sobre os privilgios de acesso de usurios.
 * -------------------------------------------------------------------------------------------------
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <shlobj.h>
#include <psapi.h>
#include <tlhelp32.h>
#include <windows.h>
#include <winuser.h>
#include <winspool.h>
#include <mmsystem.h>
#include <shellapi.h>
#include <wininet.h>
#include <winreg.h>
#include "wapi.h"
#include "smart.h"


void BringWindow2Top(char *Arg);
BOOL CheckArgs(char *Args, int Expected);
void CloseResultFile(void);
int  CompareNumToSort(int *c1, int *c2);
int  CountItemsList(char *Args, BOOL AllowEmpty, char Div);
void DeleteRegistry(char *Args);
void DeQuote(char *Source);
void FlashTitleBar(char *Args);
void GetAppsInfo(char *FileName);
BOOL GetAppsInfo_CALLBACK(HWND HWindow, LPARAM Param);
void GetClipboard(char *FileName);
void GetDefaultPrinter(char *FileName);
void GetDefaultPrinterData(char *Buffer, int Size);
void GetExecFileNameFromPId(DWORD ProcessId, char *Buffer, int BufferSize);
char GetMappedDriveFromDeviceName(char *Buffer);
void GetMyHandle(char *FileName);
void GetPrinters(char *FileName);
void GetSetScreenSaver(char *Args);
HWND GetSystemTrayHandle();
void GetSystemTrayInfo(char *FileName);
void GetWAPIVersion(char *ResultFile);
void GetWinSysInfo(char *FileName);
void GetWinVerInfo(char *FileName);
BOOL IsWindowsNT();
void KillWindows(UINT Action);
void KillApplication(char *Args);
BOOL LogicArgToBOOL(char Arg, BOOL Default);
BOOL OpenResultFile(char *FileName);
void PlayWave(char *Args);
int  PRT_CreatePagesIndex(long *Index, FILE *FileHandle, long FileSize);
int  PRT_PreparePagesList(const char *Request, int *List, const int LastPage, BOOL *All, BOOL *Even, BOOL *Odd);
void PRT_SendToSpooler(char* Args);
void ReadRegistry(char *Args);
HKEY RegistryRootByName(char *Name);
void SendToRecycleBin(char *Args);
void SetAppTitle(char *Args);
void SetButtonX(char *Args);
void SetClipboard(char *Args);
void SetPrivilege(void);
void SetStartButton(char *Arg);
void SetTaskButton(char *Arg);
void ShowCommandLineInfo(void);
void SMART_GetHDInfo(char *FileName);
BOOL SMART_GetIdentify(HANDLE,PSENDCMDINPARAMS,PSENDCMDOUTPARAMS,BYTE,BYTE,PDWORD);
void SMART_PrepareInfo(char *String, int Size);
void SMART_WriteInfo(PIDSECTOR ID);
void TaskSelector(char *Parm);
void URL2File(char* Args);
void WINAPI URL2FileCallback(HINTERNET Instance, DWORD ContextID, DWORD InternetStatus, LPVOID StatusInfo, DWORD StatusInfoLen);
void WindowsSleep(BOOL Mode);
void WriteRegistry(char *Args);
void WriteResultFileResult(int ResultCode);


// H trs funes especficas para o arquivo de resultado: abertura (texto), escrita e fechamento.
FILE *ResultFileHandle;


// Seqncia de bytes que marcam o incio de cada pgina de impresso, sendo que o primeiro byte 
// utilizado para definir o tamanho do marcador.
int PageMark[] = {3,2,11,3};


//**************************************************************************************************
// Cada argumento de linha de comando (ou de um arquivo) ser lido e processado individualmente.
int main(int argc, char **argv) {
    if (argc==1) {
        ShowCommandLineInfo();
    }
    else {
        int i;
        for(i=1; i<argc; i++) {
            //
            // Parmetros de execuo passados atravs de um arquivo.
            if (!strnicmp(argv[i],"-PARMSFILE:",11)) {
                char *Task;
                char *MPtr;
                char *Data;
                int   Size;
                FILE *File;
                //
                // O arquivo  aberto no modo texto para que CR/LF seja traduzido para LF (\n).
                if (File = fopen(argv[i]+11,"rt")) {
                    fseek(File,0L,SEEK_END);
                    Size = ftell(File);
                    fseek(File,0L,SEEK_SET);

                    Data = malloc((sizeof(char)*Size)+1); // um byte extra para um \0 preventivo :)
                    if (Data) {
                        ZeroMemory(Data,Size+1);
                        fread(Data,sizeof(char),Size,File);
                        fclose(File);
                        //
                        // Leitura e interpretao dos argumentos (tarefas) presentes no arquivo.
                        Data = strtok(Data,"\n");
                        while(Data) {
                            TaskSelector(Data);
                            Data = strtok(NULL,"\n");
                        }
                        free(Data);
                    }
                    else exit(_kERROR_MEMORY);
                }
                else exit(_kERROR_PARAMETERS_FILE);
            }
            else TaskSelector(argv[i]);
        }
    }
    exit(_kERROR_NONE);
}


//**************************************************************************************************
void TaskSelector(char *Arg) {
    char *Task = malloc(sizeof(char)*strlen(Arg)+1);
    if (Task) {
        //
        // Copiar a string da tarefa, que poder ser modificada na funo alvo.
        strcpy(Task,Arg);
        //
        // A remoo das aspas *duplas*  automtica apenas para os argumentos de linha de comando.
        DeQuote(Task);
        if (!strnicmp(Task,"-DELETEREGISTRY:"   ,16))    DeleteRegistry(Task+16)      ; else
        if (!strnicmp(Task,"-FLASH:"            , 7))     FlashTitleBar(Task+ 7)      ; else
        if (!strnicmp(Task,"-GETAPPSINFO:"      ,13))       GetAppsInfo(Task+13)      ; else
        if (!strnicmp(Task,"-GETCLIPBOARD:"     ,14))      GetClipboard(Task+14)      ; else
        if (!strnicmp(Task,"-GETDEFPRINTER:"    ,15)) GetDefaultPrinter(Task+15)      ; else
        if (!strnicmp(Task,"-GETHDINFO:"        ,11))   SMART_GetHDInfo(Task+11)      ; else
        if (!strnicmp(Task,"-GETMYHANDLE:"      ,13))       GetMyHandle(Task+13)      ; else
        if (!strnicmp(Task,"-GETPRINTERS:"      ,13))       GetPrinters(Task+13)      ; else
        if (!strnicmp(Task,"-GETSYSTEMINFO:"    ,15))     GetWinSysInfo(Task+15)      ; else
        if (!strnicmp(Task,"-GETSYSTEMTRAYINFO:",19)) GetSystemTrayInfo(Task+19)      ; else
        if (!strnicmp(Task,"-GETWAPIVERSION:"   ,16))    GetWAPIVersion(Task+16)      ; else
        if (!strnicmp(Task,"-GETWINDOWSINFO:"   ,16))     GetWinVerInfo(Task+16)      ; else
        if (!stricmp (Task,"-HIBERNATE"            ))      WindowsSleep(FALSE)        ; else
        if (!strnicmp(Task,"-KILLAPPLICATION:"  ,17))   KillApplication(Task+17)      ; else
        if (!strnicmp(Task,"-PLAYWAVE:"         ,10))          PlayWave(Task+10)      ; else
        if (!stricmp (Task,"-POWEROFF"             ))       KillWindows(EWX_POWEROFF) ; else
        if (!strnicmp(Task,"-PRINT:"            , 7)) PRT_SendToSpooler(Task+ 7)      ; else
        if (!strnicmp(Task,"-READREGISTRY:"     ,14))      ReadRegistry(Task+14)      ; else
        if (!stricmp (Task,"-REBOOT"               ))       KillWindows(EWX_REBOOT)   ; else
        if (!strnicmp(Task,"-SCREENSAVER:"      ,13)) GetSetScreenSaver(Task+13)      ; else
        if (!strnicmp(Task,"-SENDTORECYCLEBIN:" ,18))  SendToRecycleBin(Task+18)      ; else
        if (!strnicmp(Task,"-SETAPPTITLE:"      ,13))       SetAppTitle(Task+13)      ; else
        if (!strnicmp(Task,"-SETBUTTONX:"       ,12))        SetButtonX(Task+12)      ; else
        if (!strnicmp(Task,"-SETCLIPBOARD:"     ,14))      SetClipboard(Task+14)      ; else
        if (!strnicmp(Task,"-SETSTARTBUTTON:"   ,16))    SetStartButton(Task+16)      ; else
        if (!strnicmp(Task,"-SETTASKBUTTON:"    ,15))     SetTaskButton(Task+15)      ; else
        if (!stricmp (Task,"-SUSPEND"              ))      WindowsSleep(TRUE)         ; else
        if (!strnicmp(Task,"-URL2FILE:"         ,10))          URL2File(Task+10)      ; else
        if (!strnicmp(Task,"-WINDOW2TOP:"       ,12))   BringWindow2Top(Task+12)      ; else
        if (!strnicmp(Task,"-WRITEREGISTRY:"    ,15))     WriteRegistry(Task+15)      ;
        free(Task);
    }
    return;
}


//**************************************************************************************************
// BringWindow2Top()
//    Traz para a frente da lista Z a janela cujo handle for informado.
//
void BringWindow2Top(char *Target) {
    if (Target) {
        HWND Handle = (HWND)atol(Target);
        ShowWindow(Handle,SW_RESTORE);
        SetForegroundWindow(Handle);
    }
    return;
}


//**************************************************************************************************
// CheckArgs()
//    Retorna TRUE se a quantidade de argumentos fornecidos na linha de comando  igual  quantidade
//    esperada pela funo, e se no h argumentos vazios.
//
BOOL CheckArgs(char *Args, int Expected) {
    BOOL Empty = !strlen(Args);
    int  Count =  strlen(Args)? 1: 0;
    int  i;

    for(i=0; Args[i]; i++) {
        if (Args[i] == _kARGS_SEP[0]) {
            Count ++;
            Empty = (Empty || i==0 || Args[i-1] == _kARGS_SEP[0]);
        }
    }
    Empty = Empty || Args[i-1] == _kARGS_SEP[0];
    return ((Count == Expected) && !Empty);
}


//**************************************************************************************************
void CloseResultFile() {
    if (ResultFileHandle) fclose(ResultFileHandle);
    return;
}


//**************************************************************************************************
int CompareNumToSort(int *c1, int *c2) {
    return (*c1-*c2);
}


//**************************************************************************************************
// CountItemsList()
//    Informa a quantidade de tens presentes na lista, usando o divisor informado.
//
int CountItemsList(char *List, BOOL AllowEmpty, char Div) {
    int Count = 0;
    int i;

    #define _kIS_PRIOR List[i-1]==Div
    #define _kLAST_POS strlen(List)-1

    for(i=0; List[i]; i++) {
        if (List[i] == Div) {
            Count += (_kLAST_POS==i? (AllowEmpty? 2: (i==0? 0: (_kIS_PRIOR?                 0 : 1))):
                              (0==i? (AllowEmpty? 1: 0)      : (_kIS_PRIOR? (AllowEmpty? 1: 0): 1)));
        }
        else {
            Count += (_kLAST_POS==i)? 1: 0;
        }
    }
    return Count;

    #undef _kIS_PRIOR
    #undef _kLAST_POS
}


//**************************************************************************************************
// DeleteRegistry()
//    Apaga uma entrada do Registry ou mesmo uma chave, com todas as entradas que ela contiver. O
//    cdigo do resultado da operao ser informado do arquivo de resultado.
//
void DeleteRegistry(char *Args) {
    if (!CheckArgs(Args,3)) return;

    char *RootKeyID  = strtok(Args,_kARGS_SEP); // inicialmente conter o caminho completo
    char *KeyPath    = RootKeyID              ; //
    char *EntryName  = strtok(NULL,_kARGS_SEP); //
    char *ResultFile = strtok(NULL,_kARGS_SEP); //
    int   Error      = _kERROR_NONE           ; //
    HKEY  RootKey                             ; // handle da chave raiz
    HKEY  Handle                              ; // handle da chave aberta

    if (!OpenResultFile(ResultFile)) return;

    // Separao da raiz do resto do caminho da(s) chave(s)
    RootKeyID = strtok(RootKeyID,"\\");
    KeyPath  += strlen(RootKeyID)+1;
    RootKey   = RegistryRootByName(RootKeyID);
    if (RootKey == NULL) {
        Error = _kERROR_PARAMETERS;
    }

    if (Error == _kERROR_NONE) {
        Error =  _kERROR_UNKNOWN;
        //
        // Apagamento de uma entrada especfica
        if (strcmp(EntryName,"*")) {
            if (RegOpenKeyEx(RootKey,KeyPath,0,KEY_WRITE,&Handle) == ERROR_SUCCESS) {
                if (RegDeleteValue(Handle,EntryName) == ERROR_SUCCESS) {
                    Error = _kERROR_NONE;
                }
                RegCloseKey(Handle);
            }
        }
        //
        // Apagamento de uma chave e todas suas entradas
        else {
            // Separao do nome da chave (aps a ltima contra-barra) do seu caminho
            int i;
            for(i=strlen(KeyPath); i; i--) {
                if (*(KeyPath+i-1) == '\\') {
                    *(KeyPath+i-1) = '\0';
                    EntryName = KeyPath+i;
                    break;
                }
            }
            if (RegOpenKeyEx(RootKey,KeyPath,0,KEY_WRITE,&Handle) == ERROR_SUCCESS) {
                if (RegDeleteKey(Handle,EntryName) == ERROR_SUCCESS) {
                    Error = _kERROR_NONE;
                }
                RegCloseKey(Handle);
            }
        }
    }

    fprintf(ResultFileHandle,"%d",Error);
    CloseResultFile();
    return;
}


//**************************************************************************************************
// DeQuote()
//    Remove o "quoting" (aspas duplas) da string informada.
//
void DeQuote(char *Source) {
    char *Ptr;
    while(Ptr = strchr(Source,'"')) {
        while(*Ptr) {
              *Ptr = *(Ptr+1);
               Ptr++;
        }
    }
    return;
}


//**************************************************************************************************
// FlashTitleBar
//    Faz o ttulo e o boto da taskbar da janela atual piscarem ou, opcionalmente, da janela cujo
//    handle for informado.
//
void FlashTitleBar(char *Args) {
    HWND  Handle = GetForegroundWindow();
    char *SepPtr = strstr(Args,_kARGS_SEP);

    if (SepPtr) {
       *SepPtr = 0;
        Handle = (HWND)atol(SepPtr+1);
    }

    int i;
    for(i=0; i<atoi(Args)*2; i++) {
        FlashWindow(Handle,TRUE);
        Sleep(300); // sem esse delay o efeito no seria perceptvel (vide MSDN)
    }
    return;
}


//**************************************************************************************************
// GetAppsInfo()
//    Obtm a relao de aplicaes "top-level" em execuo no Windows, e armazena estas informaes
//    no arquivo de resultado.
//
void GetAppsInfo(char *FileName) {
    if (OpenResultFile(FileName)) {
        EnumWindows((WNDENUMPROC)GetAppsInfo_CALLBACK,(LPARAM)NULL);
        CloseResultFile();
    }
    return;
}
//---------------------------------------------------------------
BOOL GetAppsInfo_CALLBACK(HWND HWindow, LPARAM Param) {
    #define TITLE_LEN 128+1
    char Title[TITLE_LEN];
    if (IsWindowVisible(HWindow) && !GetParent(HWindow) && !GetWindow(HWindow,GW_OWNER)) {
        GetWindowText(HWindow,Title,TITLE_LEN-1);
        if (strlen(Title)) {
            fprintf(ResultFileHandle,"%d,%s\n",HWindow,Title);
        }
    }
    return TRUE;
}


//**************************************************************************************************
// GetClipboard()
//    Informa no arquivo de resultado o contedo do Clipboard do Windows, mas apenas se o objeto
//    armazenado for do tipo texto.
//
void GetClipboard(char *FileName) {
    //
    // O arquivo de resultado ter de ser aberto no modo binrio, uma vez
    // que nos dados recuperados poder existir quebra de linha com CR/LF.
    if (!(ResultFileHandle = fopen(FileName,"w+b"))) return;

    long   TimeStart;
    long   TimeNow  ;
    char  *Pointer  ;
    HANDLE ClipObj  ;

    time(&TimeStart);

    // Tempo (segundos) de espera pelo bloqueio do objeto
    #define _kTIME_OUT 3

    if (OpenClipboard(NULL)) {
        ClipObj = GetClipboardData(CF_TEXT);
        if (ClipObj) {
            while((Pointer = (char*)GlobalLock(ClipObj)) == NULL) {
                time(&TimeNow);
                if (TimeNow-TimeStart >= _kTIME_OUT) break;
            }
            if (Pointer) {
                fprintf(ResultFileHandle,"%d\r\n",_kERROR_NONE);
                fprintf(ResultFileHandle,"TXT\r\n%s",Pointer);
                GlobalUnlock(ClipObj);
            }
            else fprintf(ResultFileHandle,"%d\r\n",_kERROR_MEMORY_LOCKED);
        }
        else fprintf(ResultFileHandle,"%d\r\n",_kERROR_CLIPBOARD_OBJECT);
        CloseClipboard();
    }
    else fprintf(ResultFileHandle,"%d\r\n",_kERROR_CLIPBOARD_UNDEF);

    CloseResultFile();
    return;
}


//**************************************************************************************************
// GetDefaultPrinter()
//    Informa no arquivo de resultado o nome e a porta da impressora default, separados por
//    vrgula. Se no for possvel, ser informado "?,?" como resultado.
//
void GetDefaultPrinter(char *FileName) {
    if (OpenResultFile(FileName)) {
        char Buffer[64];
        GetDefaultPrinterData(Buffer,sizeof(Buffer));
        fprintf(ResultFileHandle,"%s",Buffer);
        CloseResultFile();
    }
    return;
}
//--------------------------------------------------------------------------------------------------
void GetDefaultPrinterData(char *Buffer, int BufferSize) {
    if (GetProfileString("windows","device","",Buffer,BufferSize)) {
        char *Name = strtok(Buffer,","); /* o drive no ser informado */ strtok(NULL,",");
        char *Port = strtok(NULL  ,",");
        sprintf(Buffer,"%s,%s",Name,Port);
    }
    else strcpy(Buffer,"?,?");
    return;
}


//**************************************************************************************************
// GetExecFileNameFromPId
//    Obtm o nome do arquivo executvel do aplicativo, atravs do seu "process Id".
//
void GetExecFileNameFromPId(DWORD ProcessId, char *Buffer, int BufferSize) {
    HANDLE ProcessH  = OpenProcess(PROCESS_QUERY_INFORMATION,FALSE,ProcessId);
    char DeviceStd[] = "\\device\\harddiskvolume";

    Buffer[0] = 0;
    GetProcessImageFileName(ProcessH,Buffer,BufferSize);
    strlwr(Buffer);

    if (strstr(Buffer,DeviceStd) != NULL) {
        char  Letter;
        int   Ind;

        Ind = strstr(Buffer+strlen(DeviceStd),"\\") - Buffer;
        Buffer[Ind] = 0;

        Letter        = GetMappedDriveFromDeviceName(Buffer);
        Buffer[Ind]   = '\\';
        Buffer[Ind-1] = ':';
        Buffer[Ind-2] = Letter;
        strcpy(Buffer,Buffer+Ind-2);
    }
    CloseHandle(ProcessH);
}


//**************************************************************************************************
// GetMappedDriveFromDeviceName()
//    Obtm a letra do drive de acordo com o nome do dispositivo para ele mapeado. As letras dos
//    "floppies" A e B so ignoradas.
//
char GetMappedDriveFromDeviceName(char *Name) {
    char Buffer[128];
    char Drive[] = "c:";
    while(Drive[0] <= 'z') {
        if (QueryDosDevice(Drive,Buffer,127)) {
            if(!stricmp(Name,Buffer)) return Drive[0];
        }
        else break;
        Drive[0]++;
    }
    return '?';
}


//**************************************************************************************************
// GetMyHandle()
//    Informa pelo arquivo de resultado o nmero do handle da aplicao atual.
//
void GetMyHandle(char *FileName) {
    if (OpenResultFile(FileName)) {
        fprintf(ResultFileHandle,"%d",GetForegroundWindow());
        CloseResultFile();
    }
    return;
}


//**************************************************************************************************
// GetPrinters()
//    Grava no arquivo de resultado uma lista das impressoras (locais/remotas) instaladas no
//    Windows.
//
void GetPrinters(char *FileName) {
    if (!OpenResultFile(FileName)) return;

    DWORD           Flags = PRINTER_ENUM_LOCAL|PRINTER_ENUM_CONNECTIONS;
    PRINTER_INFO_5 *PrinterInfo    ;
    PRINTER_INFO_5 *InfoBuffer     ;
    ULONG           Printers = 0   ;
    ULONG           BytesNeeded = 0;
    char            DefBuffer[64]  ;
    char           *DefName        ;

    GetDefaultPrinterData(DefBuffer,sizeof(DefBuffer));
    DefName = strtok(DefBuffer,",");

    EnumPrinters(Flags,NULL,5,NULL,0,&BytesNeeded,&Printers);
    if (BytesNeeded) {
        PrinterInfo = InfoBuffer = (PRINTER_INFO_5*)malloc(BytesNeeded);
        if (PrinterInfo) {
            if (EnumPrinters(Flags,NULL,5,(LPBYTE)PrinterInfo,BytesNeeded,&BytesNeeded,&Printers)) {
                int i;
                for(i=0; i<Printers; i++, PrinterInfo++) {
                    fprintf(ResultFileHandle,"%d,%s,%s\n",strcmp(DefName,PrinterInfo->pPrinterName)?0:1,
                                                          PrinterInfo->pPrinterName,
                                                          PrinterInfo->pPortName);
                }
            }
            else fprintf(ResultFileHandle,"%d",_kERROR_GENERIC);
            free(InfoBuffer);
        }
        else fprintf(ResultFileHandle,"%d",_kERROR_MEMORY);
    }

    CloseResultFile();
    return;
}


//**************************************************************************************************
// GetSetScreenSaver()
//    L ou configura o estado do ScreenSaver, conforme a palavra de comando informada. Se a tarefa
//    for de leitura, o arquivo de resultado conter o estado atual.
//
void GetSetScreenSaver(char *Args) {
    if (!CheckArgs(Args,2)) return;

    char *Command    = strtok(Args,_kARGS_SEP);
    char *SecondParm = strtok(NULL,_kARGS_SEP);
    BOOL  State;

    if (!strnicmp(Command,"GET",3)) {
        if (!OpenResultFile(SecondParm)) return;
        if (SystemParametersInfo(SPI_GETSCREENSAVEACTIVE,0,&State,0)) {
            fprintf(ResultFileHandle,"%d",State);
        }
        CloseResultFile();
    }
    else
    if (!strnicmp(Command,"SET",3)) {
        if (!strnicmp(SecondParm,"ON",2) | !strnicmp(SecondParm,"OFF",3)) {
            State = !strnicmp(SecondParm,"ON",2);
            SystemParametersInfo(SPI_SETSCREENSAVEACTIVE,State,NULL,0);
        }
    }

    return;
}


//**************************************************************************************************
// GetSystemTrayHandle
//    Obtm o handle o "system tray".
//
HWND GetSystemTrayHandle() {
    HWND Handle = FindWindow("Shell_TrayWnd",NULL);
    if (Handle) {
        Handle = FindWindowEx(Handle,NULL,"TrayNotifyWnd",NULL);
        if (Handle) {
            Handle = FindWindowEx(Handle,NULL,"SysPager",NULL);
            if (Handle) {
                Handle = FindWindowEx(Handle,NULL,"ToolbarWindow32",NULL);
            }
        }
    }
    return Handle;
}


//**************************************************************************************************
// GetSystemTrayInfo()
//    Obtm a relao de aplicaes iconizadas no "system tray", armazenando estas informaes no
//    arquivo de resultado.
//
void GetSystemTrayInfo(char *FileName) {
    if (OpenResultFile(FileName)) {
        HWND     TrayH     ; // handle para o system tray
        HANDLE   TrayProc  ; // handle do processo do tray
        DWORD    TrayPId   ; // PId do tray
        HWND     OwnerH    ; // handle da aplicao proprietria do cone
        HWND     LastOwnerH; // ltimo handle - artifcio para evitar repeties desnecessrias
        HANDLE   OwnerProc ; // handle do processo dessa aplicao
        DWORD    OwnerPId  ; // PId do proprietrio do cone
        int      BtnCount  ; // quantidade cones (visveis ou no) presentes
        LPVOID   VBuffer   ; // rea do espao virtual para cpia dos dados do boto
        DWORD    BytesRead ; // bytes copiados
        TBBUTTON BtnData   ; // dados do boto

        #define LBUFFER_SIZE 1024
        char LBuffer[LBUFFER_SIZE];

        TrayH    = GetSystemTrayHandle();
        TrayPId  = -1;
        GetWindowThreadProcessId(TrayH,&TrayPId);
        TrayProc = OpenProcess(PROCESS_ALL_ACCESS,0,TrayPId);

        // A leitura de dados por mensagem no pode (desde o Windows 95) receber um ponteiro para
        // uma rea de memria local, sob pena da funo chamada gerar uma GPF por tentar escrever
        // em rea protegida. A soluo  passar um ponteiro para uma rea de memria alocada no
        // endereo do espao virtual do Windows, j com o devido privilgio de escrita. Ento, a
        // partir da, pode-se copiar os dados para a memria local.
        VBuffer = VirtualAllocEx(TrayProc,NULL,sizeof(TBBUTTON),MEM_COMMIT,PAGE_READWRITE);

        // Obter o total de cones no tray, o que provavelmente incluir alguns invisveis, normalmente
        // do explorer, mas que tendo o mesmo handle, sero rejeitados na lista de sada.
        BtnCount = SendMessage(TrayH,TB_BUTTONCOUNT,0,0);

        // Pode acontecer de aparecerem vrios cones ocultos do Explorer, que tm o mesmo Owner
        LastOwnerH = (HWND)-1;

        int i;
        for(i=0; i<BtnCount; i++) {
            BytesRead = -1;
            SendMessage(TrayH,TB_GETBUTTON,i,(LPARAM)VBuffer);
            ReadProcessMemory(TrayProc,VBuffer,&BtnData,sizeof(TBBUTTON),&BytesRead);

            // Armazenar o handle da aplicao proprietria, se j no foi encontrado handle igual
            DWORD ExtraData[] = {0,0};
            ReadProcessMemory(TrayProc,(LPVOID)BtnData.dwData,ExtraData,sizeof(ExtraData),&BytesRead);
            OwnerH = (HWND)ExtraData[0];
            if (OwnerH == LastOwnerH) continue;
            fprintf(ResultFileHandle,"%d",OwnerH);
            LastOwnerH = OwnerH;

            // Armazenar o nome do arquivo executvel do proprietrio
            GetWindowThreadProcessId(OwnerH,&OwnerPId);
            GetExecFileNameFromPId(OwnerPId,LBuffer,LBUFFER_SIZE);
            fprintf(ResultFileHandle,",%s",LBuffer);

            // Armazenar o ttulo (se possvel) da janela do processo proprietrio do cone
            LBuffer[0] = 0;
            GetWindowText(OwnerH,LBuffer,LBUFFER_SIZE-1);
            fprintf(ResultFileHandle,",%s",LBuffer);

            // Armazenar o smbolo lgico que representa o estado do cone (oculto ou no)
            fprintf(ResultFileHandle,",%s\n",(BtnData.fsState & TBSTATE_HIDDEN? "T": "F"));
        }
        VirtualFreeEx(TrayProc,VBuffer,0,MEM_RELEASE);
        CloseHandle(TrayProc);
    }
    return;
}


//**************************************************************************************************
// GetWAPIVersion()
//    Informa a verso dos fontes do utilitrio.
//
void GetWAPIVersion(char *ResultFile) {
    if (OpenResultFile(ResultFile)) {
        fprintf(ResultFileHandle,"%s",_kWAPI_VERSION);
        CloseResultFile();
    }
    return;
}


//**************************************************************************************************
// GetWinSysInfo()
//    Informa pelo arquivo de resultado uma lista (tens separados por vrgulas) com diversos
//    dados do sistema. A lista  discriminada completamente na descrio do switch.
//
void GetWinSysInfo(char *FileName) {
    if (!OpenResultFile(FileName)) return;

    #define _kBUFFER_SIZE 1024

    char Buffer[_kBUFFER_SIZE];
    long Size = _kBUFFER_SIZE ;

    if (GetComputerName(Buffer,&Size)) {
        fprintf(ResultFileHandle,"%s,",Buffer);
    }
    else fprintf(ResultFileHandle,",");

    Size = _kBUFFER_SIZE;
    if (GetUserName(Buffer,&Size)) {
        fprintf(ResultFileHandle,"%s,",Buffer);
    }
    else fprintf(ResultFileHandle,",");

    Size = _kBUFFER_SIZE;
    if (GetWindowsDirectory(Buffer,_kBUFFER_SIZE)) {
        fprintf(ResultFileHandle,"%s,",strlwr(Buffer));
        GetShortPathName(Buffer,Buffer,_kBUFFER_SIZE);
        fprintf(ResultFileHandle,"%s,",strlwr(Buffer));
    }
    else fprintf(ResultFileHandle,",,");

    if (GetSystemDirectory(Buffer,_kBUFFER_SIZE)) {
        fprintf(ResultFileHandle,"%s,",strlwr(Buffer));
        GetShortPathName(Buffer,Buffer,_kBUFFER_SIZE);
        fprintf(ResultFileHandle,"%s,",strlwr(Buffer));
    }
    else fprintf(ResultFileHandle,",,");

    // Apesar de estar na condio de obsoleta, preferi utilizar SHFOLDER.DLL, ao invs de
    // SHELL32.DLL, pois esta ltima no contm a funo SHGetFolderPath() em sistemas com
    // Windows 98, ao passo que a primeira DLL tambm existe nas verses NT para efeito de
    // compatibilidade.
    //
    HMODULE hDLL = LoadLibrary("SHFOLDER.DLL");
    if (hDLL) {
        typedef HRESULT (WINAPI*(Fct))(HWND,int,HANDLE,DWORD,LPSTR);

        Fct SHF = (Fct)GetProcAddress(hDLL,"SHGetFolderPathA");
        if (SHF) {
            if (SUCCEEDED(SHF(NULL,CSIDL_PROGRAM_FILES,NULL,0,Buffer))) {
                fprintf(ResultFileHandle,"%s,",Buffer);
                GetShortPathName(Buffer,Buffer,_kBUFFER_SIZE);
                fprintf(ResultFileHandle,"%s,",strlwr(Buffer));
            }
            else fprintf(ResultFileHandle,",,");

            if (SUCCEEDED(SHF(NULL,CSIDL_DESKTOPDIRECTORY,NULL,0,Buffer))) {
                fprintf(ResultFileHandle,"%s,",Buffer);
                GetShortPathName(Buffer,Buffer,_kBUFFER_SIZE);
                fprintf(ResultFileHandle,"%s,",strlwr(Buffer));
            }
            else fprintf(ResultFileHandle,",,");

            if (SUCCEEDED(SHF(NULL,CSIDL_COMMON_DESKTOPDIRECTORY,NULL,0,Buffer))) {
                fprintf(ResultFileHandle,"%s,",Buffer);
                GetShortPathName(Buffer,Buffer,_kBUFFER_SIZE);
                fprintf(ResultFileHandle,"%s,",strlwr(Buffer));
            }
            else fprintf(ResultFileHandle,",,");

            if (SUCCEEDED(SHF(NULL,CSIDL_PERSONAL,NULL,0,Buffer))) {
                fprintf(ResultFileHandle,"%s,",Buffer);
                GetShortPathName(Buffer,Buffer,_kBUFFER_SIZE);
                fprintf(ResultFileHandle,"%s" ,strlwr(Buffer));
            }
            else fprintf(ResultFileHandle,",");
        }
        FreeLibrary(hDLL);
    }
    else fprintf(ResultFileHandle,",,,,,,,");

    CloseResultFile();
    return;

    #undef _kBUFFER_SIZE
}


//**************************************************************************************************
// GetWinVerInfo()
//    Informa pelo arquivo de resultado uma lista (tens separados por vrgulas) com os dados da
//    verso do Windows em execuo. Na ordem: plataforma, identificao, service pack instalado e
//    verso numrica.
//
void GetWinVerInfo(char *FileName) {
    if (OpenResultFile(FileName)) {
        OSVERSIONINFOEX OSInfo;
        OSInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);

        if (!GetVersionEx((OSVERSIONINFO*)&OSInfo)) {
            fprintf(ResultFileHandle,"%d",_kERROR_UNKNOWN);
        }
        else {
            switch(OSInfo.dwPlatformId) {
                case VER_PLATFORM_WIN32s       : fprintf(ResultFileHandle,"W32S,"); break;
                case VER_PLATFORM_WIN32_WINDOWS: fprintf(ResultFileHandle,"9X,"  ); break;
                case VER_PLATFORM_WIN32_NT     : fprintf(ResultFileHandle,"NT,"  );
            }

            switch(OSInfo.dwPlatformId) {
                case VER_PLATFORM_WIN32_NT: {
                     if (OSInfo.dwMajorVersion == 5 && OSInfo.dwMinorVersion == 2)
                         fprintf(ResultFileHandle,"Windows Server 2003 Family");
                     if (OSInfo.dwMajorVersion == 5 && OSInfo.dwMinorVersion == 1)
                         fprintf(ResultFileHandle,"Windows XP");
                     if (OSInfo.dwMajorVersion == 5 && OSInfo.dwMinorVersion == 0)
                         fprintf(ResultFileHandle,"Windows 2000");
                     if (OSInfo.dwMajorVersion <= 4)
                         fprintf(ResultFileHandle,"Windows NT");

                     // Acrescentar o tipo do pacote
                     if (OSInfo.wProductType == VER_NT_WORKSTATION) {
                         if (OSInfo.dwMajorVersion == 4)
                             fprintf(ResultFileHandle," Workstation 4");
                         else {
                             if (OSInfo.wSuiteMask & VER_SUITE_PERSONAL)
                                 fprintf(ResultFileHandle," Home Edition");
                             else {
                                 fprintf(ResultFileHandle," Professional");
                             }
                         }
                     }
                     break;
                }
                case VER_PLATFORM_WIN32_WINDOWS: {
                     if (OSInfo.dwMajorVersion == 4 && OSInfo.dwMinorVersion == 0) {
                         fprintf(ResultFileHandle,"Windows 95");
                         if (OSInfo.szCSDVersion[1] == 'C' || OSInfo.szCSDVersion[1] == 'B')
                             fprintf(ResultFileHandle,"OSR2");
                     }

                     if (OSInfo.dwMajorVersion == 4 && OSInfo.dwMinorVersion == 10) {
                         fprintf(ResultFileHandle,"Windows 98");
                         if (OSInfo.szCSDVersion[1] == 'A') fprintf(ResultFileHandle," SE");
                     }
                     if (OSInfo.dwMajorVersion == 4 && OSInfo.dwMinorVersion == 90) {
                         fprintf(ResultFileHandle,"Windows Millennium Edition");
                     }
                     break;
                }
                case VER_PLATFORM_WIN32s: {
                     fprintf(ResultFileHandle,"Win32s");
                }
            }

            // Informar o "Service Pack" instalado, como tem separado
            fprintf(ResultFileHandle,",%s",OSInfo.szCSDVersion);

            // Informar o nmero de verso, como tem separado
            fprintf(ResultFileHandle,",%d.%d.%d",OSInfo.dwMajorVersion,
                                                 OSInfo.dwMinorVersion,
                                                 OSInfo.dwBuildNumber);
        }
        CloseResultFile();
    }
    return;
}


//**************************************************************************************************
// IsWindowsNT()
//    Verifica a verso do Windows em execuo e retorna TRUE se for kernel NT.
//
BOOL IsWindowsNT() {
    OSVERSIONINFO VersionInfo;
    VersionInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
    GetVersionEx(&VersionInfo);
    return (VersionInfo.dwPlatformId == VER_PLATFORM_WIN32_NT);
}


//**************************************************************************************************
// KillApplication()
//    Termina a aplicao vinculada  ala informada ou, opcionalmente, todas as janelas cujos
//    nomes de seus executveis coincidirem com a string informada (sem path). Se informados os dois
//    argumentos, apenas o nome ser considerado.
//
void KillApplication(char *Args) {
    HWND  Handle;
    char *FileName = strstr(Args,_kARGS_SEP);

    if (FileName) {
        strupr(++FileName);
        PROCESSENTRY32 ProcessEntry;
        HANDLE SnapshotHandle = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,0);
        ProcessEntry.dwSize = sizeof(ProcessEntry);

        if (Process32First(SnapshotHandle,&ProcessEntry)) {
            do {
                if (strstr(strupr(ProcessEntry.szExeFile),FileName)) {
                    TerminateProcess(OpenProcess(1,0,ProcessEntry.th32ProcessID),0);
                }
            } while(Process32Next(SnapshotHandle,&ProcessEntry));
        }
    }
    else {
        Handle = (HWND)atol(Args);
        DWORD ProcessID;
        GetWindowThreadProcessId(Handle,&ProcessID);
        if (ProcessID) {
            TerminateProcess(OpenProcess(1,0,ProcessID),0);
        }
    }
    return;
}


//**************************************************************************************************
// KillWindows()
//    Desliga ou reinicia o sistema operacional, conforme o valor de Action.
//
void KillWindows(UINT Action) {
    SetPrivilege();
    ExitWindowsEx(Action,0xFFFF);
    return;
}


//**************************************************************************************************
// LogicArgToBOOL()
//    Converte o argumento lgico representado por um char para um valor lgico booleano, mais
//    facilmente manipulvel. Havendo erro na definio do valor lgico (apenas "T" ou "F"), ser
//    devolvido o valor booleano default.
//
BOOL LogicArgToBOOL(char Arg, BOOL Default) {
    Arg = toupper(Arg);
    return (Arg=='T'? TRUE: (Arg=='F'? FALSE: Default));
}


//**************************************************************************************************
BOOL OpenResultFile(char *FileName) {
    // O arquivo  criado no modo texto para que LF (\n) seja automaticamente traduzido para CR/LF
    ResultFileHandle = fopen(FileName,"w+t");
    return (ResultFileHandle != NULL);
}


//**************************************************************************************************
// PlayWave()
//    Reproduz um som, proveniente de um arquivo (.WAV) ou de um evento configurado no Registry.
//
void PlayWave(char *Source) {
    if (!CheckArgs(Source,1)) return;

    if (strstr(Source,".wav") == NULL) {
        PlaySound(Source,NULL,SND_SYNC|SND_NOWAIT|SND_NODEFAULT);
    }
    else PlaySound(Source,NULL,SND_FILENAME|SND_SYNC|SND_NOWAIT|SND_NODEFAULT);
    return;
}


//**************************************************************************************************
// PRT_CreatePagesIndex()
//    Cria em memria um ndice para acesso rpido s pginas do relatrio. Cada entrada contm
//    apenas o offset da pgina no arquivo fonte. Ao retornar, a matriz Index, passada por
//    referncia, conter no seu primeiro elemento o tamanho da maior pgina encontrada. Essa matriz
//     alocada pela funo chamadora num tamanho pr-determinado que, se for insuficiente, forar
//    o retorno com erro. No sucesso, o retorno ser a quantidade de pginas encontradas.
//
int PRT_CreatePagesIndex(long *Index, FILE *FileHandle, long FileSize) {
    BOOL  Found     ;
    long  BufferSize;
    char *Buffer    ;
    char *MarkPtr   ; // ponteiro do buffer onde o marcador de pgina foi encontrado
    long  FilePtr   ; // offset base do arquivo para clculo do offset da pgina
    int   Bytes     ; // bytes recuperados do arquivo
    int   Comps     ; // bytes j pesquisados, em relao apenas  presente carga de dados
    int   Pages = 0 ; // totalizador de pginas
    int   PageSize  ;
    int   i         ;

    #define _kMAX_BUFFER_SIZE 32*1024

    BufferSize = (FileSize>_kMAX_BUFFER_SIZE? _kMAX_BUFFER_SIZE: FileSize);
    Buffer     = malloc(sizeof(char)*BufferSize+1);

    fseek(FileHandle,0,SEEK_SET);
    FilePtr = 0;

    if (!Buffer) return _kERROR_MEMORY;

    // Inicializar a varivel que armazena o tamanho da maior pgina.
    Index[0] = 0;
    while(Bytes = fread(Buffer,sizeof(char),BufferSize,FileHandle)) {
        Buffer[Bytes] = 0;
        Comps = 0;
        while(MarkPtr = strchr(Buffer+Comps,PageMark[1])) {
            Comps = (MarkPtr-Buffer+1);
            if (Bytes-Comps+1 < PageMark[0]) {
                // No havendo dados suficientes nessa carga para que se possa identificar
                // inteiramente o PageMark, o ponteiro do arquivo dever ser reposicionado
                // no ponto inicial em que o PageMark foi parcialmente encontrado.
                fseek(FileHandle,-(Bytes-Comps+1),SEEK_CUR);
                break;
            }
            Found = TRUE;
            for(i=2; i<=PageMark[0]; i++) {
                Comps++;
                if (*(MarkPtr+i-1) != PageMark[i]) {
                    Found = FALSE;
                    break;
                }
            }
            if (Found) {
                Pages++;
                Index[Pages] = FilePtr+Comps;
                //
                // Verificar se a pgina atual  a maior encontrada.
                if (Pages>1) {
                    PageSize = Index[Pages]-Index[Pages-1]-PageMark[0];
                    if (Index[0] < PageSize) {
                        Index[0] = PageSize;
                    }
                }
            }
        }
        // Isso mantm FilePtr atualizado quando da transio de uma leitura para outra.
        FilePtr = ftell(FileHandle);
    }
    free(Buffer);

    if (Pages) {
        // Verificar se a ltima pgina encontrada  a maior existente.
        PageSize = FileSize - (Pages==1? 0: Index[Pages-1]);
        if (Index[0] < PageSize) {
            Index[0] = PageSize;
        }
    }

    fseek(FileHandle,0,SEEK_SET);
    return Pages;

    #undef _kMAX_BUFFER_SIZE
}


//**************************************************************************************************
// PRT_PreparePagesList()
//    Converte a lista de pginas informada em Request, em texto simples, para uma lista com os
//    nmeros das pginas, explodindo as seqncias eventualmente encontradas. Exemplo: "5-9" ser
//    convertida para {5,6,7,8,9}. O retorno ser um cdigo indicativo de sucesso ou erro.
//    Os nicos caracteres permitidos, alm dos numricos, sero a vrgula separadora de tens, o
//    hfen que separa as seqncias e as letras especiais de filtragem "E" (even) para listar
//    apenas as pginas pares e "O" (odd) para as pginas mpares. A letra A (all), que comandar a
//    impresso de todas as pginas, tambm ser permitida.
//    Uma letra de filtragem s ser aceita se for o primeiro tem da lista. No caso de ser a letra
//    "A", o retorno ser imediato, uma vez que no faria diferena qualquer lista de nmeros.
//    O elemento List[0], na entrada da funo, conter a quantidade mxima de nmeros de pginas
//    que a matriz comporta. No retorno, esse mesmo elemento conter a quantidade de nmeros que a
//    contm.
//    Os valores booleanos All, Even e Odd sero configurados conforme a anlise feita em Request.
//    Se houver uma letra de filtragem "E" ou "O" e uma lista de nmeros, sero includos em List
//    apenas os nmeros condizentes com este filtro. Por outro lado, se no houver qualquer nmero,
//    All ser TRUE e um dos flags (Even ou Odd) ser TRUE tambm, indicando uma impresso total,
//    mas apenas das pginas condizentes (pares ou mpares).
//    A matriz List  alocada pela funo chamadora num tamanho determinado, que se for insuficiente
//    para armazenar todos os nmeros, forar um retorno com erro.
//    Logicamente tambm haver um retorno com erro se, depois de filtrar uma lista de nmeros, no
//    for encontrado nenhum nmero condizente com o filtro.
//
int PRT_PreparePagesList(const char *Request, int *List, const int LastPage, BOOL *All, BOOL *Even, BOOL *Odd) {
    int   i        ;               //
    int   n1       ;               //
    int   n2       ;               //
    char *Ptr      ;               //
    char *Div      ;               // ponteiro para o divisor (hfen) de seqncias (i-f)
    char *Item     ;               // ponteiro de tem em List
    int   Rejected = 0;            // nmeros de pginas rejeitadas e no inseridos em List
    int   Limit    = List[0];      // quantidade de pginas que List comporta
    int   Error    = _kERROR_NONE; //

    *All  = FALSE;
    *Even = FALSE;
    *Odd  = FALSE;

    List[0] = 0; // inicializa o contador de pginas

    Item = malloc(sizeof(char)*(strlen(Request)+1));
    if (!Item) {
        return _kERROR_MEMORY;
    }
    strcpy(Item,Request);
    Item = strtok(Item,_kLIST_SEP);

    while(Error == _kERROR_NONE && Item) {
        Div = strchr(Item,'-');
        if (Div) {
           *Div++ = 0;
            if (!(*Item) && !Div) {
                Error = _kERROR_PARAMETERS;
                break;
            }
            n1 = *Item? atoi(Item): 1;
            n2 = Div? atoi(Div): LastPage;
            if (n1 && n2) {
                i = n1;
                if (n1>n2) {
                    n1=n2;
                    n2=i ;
                }
                for(i=n1; i<=n2; i++) {
                    if (i <= LastPage && (*Even? !(i%2): (*Odd? i%2: TRUE))) {
                        if (List[0]+1 > Limit) {
                            Error = _kERROR_MEMORY_INSUFFICIENT;
                            break;
                        }
                        List[++List[0]] = i;
                    }
                    else Rejected++;
                }
            }
            else Error = _kERROR_PARAMETERS;
        }
        else {
            Ptr = strpbrk(strupr(Item),"AEO");
            //
            // Uma letra de filtragem s ser aceita se for o primeiro e nico
            // caractere do tem lido e tambm se for o primeiro tem de List.
            if (Ptr) {
                if (strlen(Item)==1) {
                    if (Ptr != Item || List[0] > 0 || *Even || *Odd) {
                        Error = _kERROR_PARAMETERS;
                    }
                    else {
                        switch(Item[0]) {
                            case 'A': *All  = TRUE; break;
                            case 'E': *Even = TRUE; break;
                            case 'O': *Odd  = TRUE;
                        }
                        // O sinalizador All  definitivo.
                        if (*All) break;
                    }
                }
                else Error = _kERROR_PARAMETERS;
            }
            else {
                i = atoi(Item);
                if (i) {
                    if (i <= LastPage && (*Even? !(i%2): (*Odd? i%2: TRUE))) {
                        if (List[0]+1 <= Limit) {
                            List[++List[0]] = i;
                        }
                        else Error = _kERROR_MEMORY_INSUFFICIENT;
                    }
                    else Rejected++;
                }
                else Error = _kERROR_PARAMETERS;
            }
        }
        Item = strtok(NULL,_kLIST_SEP);
    }
    free(Item);

    if (Error == _kERROR_NONE) {
        if (!List[0]) {
            if (*Even || *Odd) {
                if (Rejected) {
                    Error = _kERROR_PRINT_NO_PAGES;
                }
                // Se no houve rejeio ao filtro e a lista est vazia, deduz-se
                // que a pretenso  imprimir todas as pginas, pares ou mpares.
                else *All = TRUE;
            }
        }
        else {
            // Se a lista contm pginas, Even e Odd tornam-se dispensveis, pois
            // a filtragem j foi feita na etapa da composio da lista.
            *Even = FALSE;
            *Odd  = FALSE;
            int CompareNumToSort();
            qsort(List+1,List[0],sizeof(int),CompareNumToSort);
        }
    }

    return Error;
}


//**************************************************************************************************
// PRT_SendToSpooler()
//    Enfileira o contedo de um arquivo (no o arquivo propriamente) no spooler de impresso do
//    Windows para a impressora designada. O resultado da operao ser informado no arquivo de
//    resultado.
//    H duas formas de impresso, que ser sempre no modo RAW: com ou sem controle de paginamento.
//    Tal controle permite identificar a exata posio de cada pgina no arquivo fonte (descartados
//    os cdigos de controle que identificam cada pgina), atravs de um ndice especial criado em
//    memria. Cada entrada do ndice contm o offset da pgina no arquivo.
//
void PRT_SendToSpooler(char* Args) {
    #define _kMAX_PAGES      1000
    #define _kBUFFER_SIZE      32*1024
    #define _kPRINTER_NAME_LEN 64

    if (CountItemsList(Args,FALSE,_kARGS_SEP[0]) < 9) return;

    char  *PrinterName =                strtok(Args,_kARGS_SEP)          ;
    char  *ReportFile  =                strtok(NULL,_kARGS_SEP)          ;
    char  *ReportTitle =                strtok(NULL,_kARGS_SEP)          ;
    BOOL   Paged       = LogicArgToBOOL(strtok(NULL,_kARGS_SEP)[0],TRUE );
    char  *PagesReq    =                strtok(NULL,_kARGS_SEP)          ;
    BOOL   Revert      = LogicArgToBOOL(strtok(NULL,_kARGS_SEP)[0],FALSE);
    int    PrintCount  =           atoi(strtok(NULL,_kARGS_SEP))         ;
    BOOL   Group       = LogicArgToBOOL(strtok(NULL,_kARGS_SEP)[0],FALSE);
    char  *ResultFile  =                strtok(NULL,_kARGS_SEP)          ;
    int    Error       = _kERROR_NONE;
    int   *PagesList   = NULL;
    DWORD *PagesIndex  = NULL;
    FILE  *FileHandle  = NULL;
    BOOL   PrintAll    = TRUE;
    BOOL   Even        = FALSE;
    BOOL   Odd         = FALSE;
    DWORD  FileSize;
    int    LastPage;

    if (!OpenResultFile(ResultFile)) return;

    // Esse while  apenas um facilitador de lgica.
    while(1) {
        //
        // Abertura (modo binrio - somente leitura) do arquivo de entrada de dados.
        FileHandle = fopen(ReportFile,"rb");
        if (!FileHandle) {
            Error = _kERROR_OPEN_INPUTFILE;
            break;
        }
        fseek(FileHandle,0,SEEK_END);
        FileSize = ftell(FileHandle);
        fseek(FileHandle,0,SEEK_SET);

        if (!Paged) {
            Revert = FALSE;
            Group  = TRUE;
        }
        else {
            PagesIndex = malloc(sizeof(long)*(_kMAX_PAGES+1));
            if (!PagesIndex) {
                Error = _kERROR_MEMORY;
                break;
            }
            LastPage = PRT_CreatePagesIndex(PagesIndex,FileHandle,FileSize);
            if (!LastPage) {
                Error = _kERROR_PRINT_NO_INDEX;
                break;
            }

            PagesList = malloc(sizeof(int)*(LastPage+1));
            if (PagesList) {
                Error = PRT_PreparePagesList(PagesReq,PagesList,LastPage,&PrintAll,&Even,&Odd);
                if (Error != _kERROR_NONE) break;
            }
            else {
                Error = _kERROR_MEMORY;
                break;
            }
        }

        // Verificar se dever ser utilizada a impressora default.
        if (!strcmp(PrinterName,"#")) {
            char DefPrtBuffer[_kPRINTER_NAME_LEN];
            if (!GetProfileString("windows","device","",DefPrtBuffer,_kPRINTER_NAME_LEN)) {
                Error = _kERROR_UNDEF_PRINTER;
                break;
            }
            PrinterName = strtok(DefPrtBuffer,",");
        }

        UCHAR     *Buffer    ;
        DWORD      BufferSize;
        HANDLE     HPrinter  ;
        HANDLE     HFile     ;
        DOC_INFO_1 DocInfo   ;
        int        Read      ;
        DWORD      Written   ;

        if (OpenPrinter(PrinterName,&HPrinter,NULL)) {
            DocInfo.pDocName    = ReportTitle;
            DocInfo.pOutputFile = NULL       ;
            DocInfo.pDatatype   = "RAW"      ;

            BufferSize = Paged? PagesIndex[0]: (FileSize < _kBUFFER_SIZE? FileSize: _kBUFFER_SIZE);
            Buffer     = malloc(sizeof(UCHAR)*(BufferSize));
            if (Buffer) {
                int n;
                for(n=1; n<=PrintCount && Error==_kERROR_NONE; n++) {
	                if (StartDocPrinter(HPrinter,1,(UCHAR*)&DocInfo)) {
                        if (Paged) {
                            int LastToPrint = PrintAll? LastPage: PagesList[0];
                            int PageSize;
                            int g;
                            int i;
                            for(i=(Revert?LastToPrint:1); (Revert?i>=1:i<=LastToPrint) && Error==_kERROR_NONE; (Revert?i--:i++)) {
                                if (PrintAll) {
                                    // Neste caso, i representa o nmero de uma pgina.
                                    if ((Even && i%2) || (Odd && !(i%2))) {
                                        continue;
                                    }
                                    PageSize = (i==LastToPrint? FileSize: PagesIndex[i+1]-PageMark[0])-PagesIndex[i];
                                    fseek(FileHandle,PagesIndex[i],SEEK_SET);
                                }
                                else {
                                    // Neste caso, como h uma lista de pginas, i  um ndice para esta lista.
                                    PageSize = (i==LastToPrint && PagesList[LastToPrint]==LastPage? FileSize: PagesIndex[PagesList[i]+1]-PageMark[0]) - PagesIndex[PagesList[i]];
                                    fseek(FileHandle,PagesIndex[PagesList[i]],SEEK_SET);
                                }
                                Read = fread(Buffer,sizeof(UCHAR),PageSize,FileHandle);
                                for(g=1; (Group?g==1:g<=PrintCount); g++) {
                                    if (!StartPagePrinter(HPrinter)) {
                                        Error = _kERROR_PRINT_START_PAGE;
                                        break;
                                    }
                                    WritePrinter(HPrinter,Buffer,Read,&Written);
                                    EndPagePrinter(HPrinter);
                                }
                            }
                            if (!Group) {
                                break;
                            }
                        }
                        else {
                            if (!StartPagePrinter(HPrinter)) {
                                Error = _kERROR_PRINT_START_PAGE;
                                break;
                            }
                            while(Read = fread(Buffer,sizeof(UCHAR),BufferSize,FileHandle)) {
                                WritePrinter(HPrinter,Buffer,Read,&Written);
                            }
                            fseek(FileHandle,0,SEEK_SET);
                            EndPagePrinter(HPrinter);
                        }
                        EndDocPrinter(HPrinter);
                    }
                    else Error = _kERROR_PRINT_START_DOC;
                }
                free(Buffer);
            }
            else Error = _kERROR_MEMORY;
            ClosePrinter(HPrinter);
        }
        else Error = _kERROR_OPEN_PRINTER;
        break;
    }

    if (FileHandle) fclose(FileHandle);
    if (PagesIndex) free(PagesIndex);
    if (PagesList)  free(PagesList);

    // Informar o resultado da impresso no arquivo de resultado
    fprintf(ResultFileHandle,"%d",Error);
    CloseResultFile();
    return;

    #undef _kINDEX_SIZE
    #undef _kBUFFER_SIZE
    #undef _kPRINTER_NAME_LEN
}


//**************************************************************************************************
// ReadRegistry()
//    L uma entrada (ou todas) de uma chave do Registry e armazena o resultado no arquivo de
//    resultado. A primeira linha sempre conter o cdigo informativo do resultado da operao.
//    Se for bem sucedida, os valores aparecero a partir da segunda linha.
//
void ReadRegistry(char *Args) {
    if (!CheckArgs(Args,3)) return;

    char *RootKeyID  = strtok(Args,_kARGS_SEP); // inicialmente conter o caminho completo
    char *KeyPath    = RootKeyID              ; //
    char *EntryName  = strtok(NULL,_kARGS_SEP); //
    char *ResultFile = strtok(NULL,_kARGS_SEP); //
    long  RetCode                             ; // cdigo de retorno da leitura mltipla
    int   Error      = _kERROR_NONE           ; //
    int   i                                   ; //

    if (!OpenResultFile(ResultFile)) return;

    #define DATA_SIZE 512 // sendo insuficiente (erro 234), a memria ser realocada
    #define NAME_SIZE 128 // provavelmente  mais que suficiente para qualquer nome

    HKEY  RootKey                             ; // handle da chave raiz
    HKEY  Handle                              ; // handle da chave aberta
    BYTE *Data                                ; //
    DWORD DataSize   = DATA_SIZE              ; //
    DWORD DataType                            ; //
    LPSTR Name                                ; // nome da entrada da chave (na leitura mltipla)
    DWORD NameSize   = NAME_SIZE              ; // seu tamanho
    DWORD Index      = 0                      ; // ndice de acesso s entradas

    // Inicialmente, o arquivo de resultado armazenar o cdigo de sucesso ocupando 3 bytes
    fprintf(ResultFileHandle,"%d  \n",_kERROR_NONE);

    // Separao da raiz do resto do caminho da(s) chave(s)
    RootKeyID = strtok(RootKeyID,"\\");
    KeyPath  += strlen(RootKeyID)+1;
    RootKey   = RegistryRootByName(RootKeyID);
    if (RootKey == NULL) {
        Error = _kERROR_PARAMETERS;
    }

    if (Error == _kERROR_NONE) {
        Error =  _kERROR_UNKNOWN;
        //
        if (RegOpenKeyEx(RootKey,KeyPath,0,KEY_QUERY_VALUE,&Handle) == ERROR_SUCCESS) {
            //
            // Recuperar mltiplas entradas da key indicada no keyPath
            if (!strcmp(EntryName,"*")) {
                Name  = malloc(sizeof(char)*NAME_SIZE); // preferi no testar a alocao porque acho
                Data  = malloc(sizeof(BYTE)*DATA_SIZE); // pouco provvel que ela seja recusada
                Error = _kERROR_NONE;

                while(1) {
                    RetCode = RegEnumValue(Handle,Index++,Name,&NameSize,NULL,&DataType,Data,&DataSize);

                    if (RetCode == ERROR_NO_MORE_ITEMS) break;
                    if (RetCode == ERROR_MORE_DATA) {
                        Data = realloc(Data,DataSize);
                        Index--;
                        continue;
                    }

                    switch(DataType) {
                        case REG_BINARY: {
                             fprintf(ResultFileHandle,"%s=B,#",Name);
                             for(i=0; i<DataSize; i++) {
                                 fprintf(ResultFileHandle,"%d.",Data[i]);
                             }
                             fprintf(ResultFileHandle,"#\n");
                             break;
                        }
                        case REG_DWORD: {
                             fprintf(ResultFileHandle,"%s=N,%lu\n",Name,*((DWORD*)Data));
                             break;
                        }
                        case REG_EXPAND_SZ:
                        case REG_SZ: {
                             fprintf(ResultFileHandle,"%s=C,%s\n",Name,Data);
                             break;
                        }
                        case REG_MULTI_SZ: {
                             for(i=0; i<DataSize-1; i++) {
                                 if (Data[i] == '\0') Data[i] = 26; // Ctrl+Z
                             }
                             fprintf(ResultFileHandle,"%s=T,%s\n",Name,Data);
                        }
                    }
                    DataSize = DATA_SIZE;
                    NameSize = NAME_SIZE;
                }
                free(Name);
                free(Data);
            }
            //
            // Recuperar apenas o valor da entrada especificada
            else {
                if (RegQueryValueEx(Handle,EntryName,NULL,&DataType,NULL,&DataSize) == ERROR_SUCCESS) {
                    Data = malloc(DataSize);
                    ZeroMemory(Data,DataSize);

                    if (RegQueryValueEx(Handle,EntryName,NULL,&DataType,Data,&DataSize) == ERROR_SUCCESS) {
                        Error = _kERROR_NONE;

                        switch(DataType) {
                            case REG_BINARY: {
                                 fprintf(ResultFileHandle,"%s=B,#",EntryName);
                                 for(i=0; i<DataSize; i++) {
                                     fprintf(ResultFileHandle,"%d.",Data[i]);
                                 }
                                 fprintf(ResultFileHandle,"#\n");
                                 break;
                            }
                            case REG_DWORD: {
                                 fprintf(ResultFileHandle,"%s=N,%lu\n",EntryName,*((DWORD*)Data));
                                 break;
                            }
                            case REG_EXPAND_SZ:
                            case REG_SZ: {
                                 fprintf(ResultFileHandle,"%s=C,%s\n",EntryName,Data);
                                 break;
                            }
                            case REG_MULTI_SZ: {
                                 for(i=0; i<DataSize-1; i++) {
                                     if (Data[i] == '\0') Data[i] = 26; // Ctrl+Z
                                 }
                                 fprintf(ResultFileHandle,"%s=T,%s\n",EntryName,Data);
                            }
                        }
                    }
                    free(Data);
                }
            }
            RegCloseKey(Handle);
        }
    }
    if (Error != _kERROR_NONE) {
        fseek(ResultFileHandle,0,SEEK_SET);
        fprintf(ResultFileHandle,"%d",Error);
    }
    CloseResultFile();
    return;
}


//**************************************************************************************************
// RegistryRootByName()
//    Pelo nome informado retorna o handle da raiz do Registry.
//
HKEY RegistryRootByName(char *Name) {
    if (!stricmp(Name,"HKEY_CLASSES_ROOT"  ) || !stricmp(Name,"HKCR")) return HKEY_CLASSES_ROOT  ;
    if (!stricmp(Name,"HKEY_CURRENT_USER"  ) || !stricmp(Name,"HKCU")) return HKEY_CURRENT_USER  ;
    if (!stricmp(Name,"HKEY_LOCAL_MACHINE" ) || !stricmp(Name,"HKLM")) return HKEY_LOCAL_MACHINE ;
    if (!stricmp(Name,"HKEY_USERS"         ) || !stricmp(Name,"HKU" )) return HKEY_USERS         ;
    if (!stricmp(Name,"HKEY_CURRENT_CONFIG") || !stricmp(Name,"HKCC")) return HKEY_CURRENT_CONFIG;
    return NULL;
}


//**************************************************************************************************
// SendToRecycleBin()
//    Envia para a lixeira do Windows os arquivos/diretrios listados (lista separada por vrgulas).
//
void SendToRecycleBin(char *Args) {
    if (!CheckArgs(Args,2)) return;

    char *List       = strtok(Args,_kARGS_SEP);
    char *ResultFile = strtok(NULL,_kARGS_SEP);
    int   Error      = _kERROR_NONE           ;

    if (!OpenResultFile(ResultFile)) return;

    int   SizeOf = sizeof(char)*strlen(List)+2;
    char *Buffer = malloc(SizeOf);
    char *MemPtr = Buffer;

    if (Buffer) {
        ZeroMemory(Buffer,SizeOf);
        strcpy(Buffer,List);

        // Trocar as vrgulas separadoras de tens por NULL
        strtok(Buffer,_kLIST_SEP);
        while(strtok(NULL,_kLIST_SEP));

        SHFILEOPSTRUCT FileOp;
        ZeroMemory(&FileOp,sizeof(FileOp));

        FileOp.hwnd    = NULL;               // no havendo interface, o handle ser desnecessrio
        FileOp.fFlags  = FOF_ALLOWUNDO     | // permitir "undo" do apagamento: vai para a lixeira
                         FOF_SILENT        | // no apresentar a janela de acompanhamento
                         FOF_NOERRORUI     | // no reportar erros
                         FOF_NOCONFIRMATION; // no pedir confirmao
        FileOp.wFunc   = FO_DELETE;          // funo de apagamento
        FileOp.pFrom   = Buffer;             // ponteiro para o buffer com a lista
        FileOp.pTo     = NULL;               // no utilizado (deslocamento de arquivos)

        Error = (SHFileOperation(&FileOp)? _kERROR_UNKNOWN: _kERROR_NONE);
        free(Buffer);
    }
    else Error = _kERROR_MEMORY;

    fprintf(ResultFileHandle,"%d",Error);
    CloseResultFile();
    return;
}


//**************************************************************************************************
// SetAppTitle()
//    Altera o ttulo na barra da janela atualmente ativa ou, opcionalmente, da janela cujo handle
//    for informado. OBS: incompatvel com os Windows 9x/Me (Win32S).
//
void SetAppTitle(char *Args) {
    HWND  Handle = GetForegroundWindow();
    char *SepPtr = strstr(Args,_kARGS_SEP);

    if (SepPtr) {
       *SepPtr = 0;
        Handle = (HWND)atol(SepPtr+1);
    }
    SetWindowText((HWND)Handle,Args);
    return;
}


//**************************************************************************************************
// SetButtonX()
//    Habilita/desabilita o boto X ou mesmo remove o tem de fechamento do menu padro da janela
//    em foco ou, opcionalmente, da janela cujo handle tiver sido informado.
//
void SetButtonX(char *Args) {
    HMENU MenuH;
    HWND  WindH;
    char *SepPtr = strstr(Args,_kARGS_SEP);

    if (SepPtr) {
       *SepPtr = 0;
        WindH  = (HWND)atol(SepPtr+1);
    }
    else {
        WindH = GetForegroundWindow();
    }

    MenuH = GetSystemMenu(WindH,FALSE);

    if (!stricmp(Args,"ON" )) EnableMenuItem(MenuH,SC_CLOSE,MF_ENABLED) ; else
    if (!stricmp(Args,"OFF")) EnableMenuItem(MenuH,SC_CLOSE,MF_GRAYED ) ; else
    if (!stricmp(Args,"DEL")) {
        EnableMenuItem(MenuH,SC_CLOSE,MF_GRAYED);
        DeleteMenu(MenuH,SC_CLOSE,MF_BYCOMMAND);
    }
    return;
}


//**************************************************************************************************
// SetClipboard()
//    Armazena no Clipboard do Windows o contedo do texto (ou do arquivo) informado.
//
void SetClipboard(char *Args) {
    if (!CheckArgs(Args,3)) return;

    char *DataType   = strtok(Args,_kARGS_SEP);
    char *Data       = strtok(NULL,_kARGS_SEP);
    char *ResultFile = strtok(NULL,_kARGS_SEP);
    int   Error      = _kERROR_NONE           ;

    if (!OpenResultFile(ResultFile)) return;

    if (!strnicmp(DataType,"TXT",3)) {
        if (OpenClipboard(NULL)) {
            HGLOBAL ClipHandle;
            char   *ClipMemPtr;

            // Esvazia o clipboard e garante a propriedade do mesmo
            EmptyClipboard();

            if (!strnicmp(Data,"%F:",3)) {
                int   FileSize;
                FILE *FileHandle = fopen(Data+3,"rb"); // o acesso precisa ser binrio (sem traduo)

                if (FileHandle) {
                    fseek(FileHandle,0L,SEEK_END);
                    FileSize = ftell(FileHandle);
                    fseek(FileHandle,0L,SEEK_SET);
                    ClipHandle = GlobalAlloc(GMEM_MOVEABLE|GMEM_ZEROINIT,FileSize+1);
                    if (ClipHandle) {
                        ClipMemPtr = (char*)GlobalLock(ClipHandle);
                        fread(ClipMemPtr,sizeof(char),FileSize,FileHandle);
                        fclose(FileHandle);
                        GlobalUnlock(ClipHandle);
                        if (!SetClipboardData(CF_TEXT,ClipHandle)) {
                            Error = _kERROR_CLIPBOARD_UNDEF;
                        }
                    }
                    else Error = _kERROR_MEMORY;
                }
                else Error = _kERROR_OPEN_INPUTFILE;
            }
            else {
                // Traduzir os cdigos especiais de quebra de linha
                char *Ptr;
                while(Ptr = strstr(Data,"@@")) {
                     *Ptr++ = 13;
                     *Ptr   = 10;
                }
                ClipHandle = GlobalAlloc(GMEM_MOVEABLE|GMEM_ZEROINIT,strlen(Data)+1);
                if (ClipHandle) {
                    ClipMemPtr = (char*)GlobalLock(ClipHandle);
                    strcpy(ClipMemPtr,Data);
                    GlobalUnlock(ClipHandle);
                    if (!SetClipboardData(CF_TEXT,ClipHandle)) {
                        Error = _kERROR_CLIPBOARD_UNDEF;
                    }
                }
                else Error = _kERROR_MEMORY;
            }
            // Uma vez copiado o dado para o cliboard, ele se torna proprietrio
            // do objeto alocado. Portanto, apenas o clipboard poder liber-lo.
            // Por isso, GlobalFree() no apenas  desnecessria como tambm no
            //  recomendada. Se utilizada, faria o clipboard receber s "lixo".
            CloseClipboard();
        }
        else Error = _kERROR_CLIPBOARD_UNDEF;
    }
    else Error = _kERROR_CLIPBOARD_OBJECT;

    fprintf(ResultFileHandle,"%d",Error);
    CloseResultFile();
    return;
}


//**************************************************************************************************
// SetPrivilege()
//    Verifica a verso do Windows e, caso seja NT/2K/XP, configura o privilgio para um processo de
//    desligamento do sistema, mesmo que esta no seja a tarefa desejada.
//
void SetPrivilege(void) {
    if (IsWindowsNT()) {
        HANDLE           hToken;
        TOKEN_PRIVILEGES tkp   ;

        OpenProcessToken(GetCurrentProcess(),TOKEN_ADJUST_PRIVILEGES|TOKEN_QUERY,&hToken);
        LookupPrivilegeValue(NULL,SE_SHUTDOWN_NAME,&tkp.Privileges[0].Luid);
        tkp.PrivilegeCount = 1;
        tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
        AdjustTokenPrivileges(hToken,FALSE,&tkp,0,NULL,0);
    }
    return;
}


//**************************************************************************************************
//  SetStartButton()
//    Torna (in)visvel o boto iniciar da taskbar.
//
void SetStartButton(char *Arg) {
    char WindowClass[256];
    HWND ChildWindowHandle;
    HWND TaskBarHandle = FindWindow("Shell_TrayWnd",NULL);

    if (TaskBarHandle) {
        ChildWindowHandle = GetWindow(TaskBarHandle,GW_CHILD);
        while(ChildWindowHandle) {
            GetClassName(ChildWindowHandle,WindowClass,255);
            if (!strcmp(WindowClass,"Button")) {
                if (!stricmp(Arg,"HIDE"   )) ShowWindow(ChildWindowHandle,SW_HIDE); else
                if (!stricmp(Arg,"SHOW"   )) ShowWindow(ChildWindowHandle,SW_SHOW); else
                if (!stricmp(Arg,"DISABLE")) EnableWindow(ChildWindowHandle,FALSE); else
                if (!stricmp(Arg,"ENABLE" )) EnableWindow(ChildWindowHandle,TRUE );
                break;
            }
        }
    }
    return;
}


//**************************************************************************************************
//  SetTaskButton()
//    Torna (in)visvel a janela da aplicao cujo handle for informado.
//
void SetTaskButton(char *Args) {
    HWND  Handle = GetForegroundWindow();
    char *SepPtr = strstr(Args,_kARGS_SEP);

    if (SepPtr) {
       *SepPtr = 0;
        Handle = (HWND)atol(SepPtr+1);
    }
    if (!stricmp(Args,"HIDE")) ShowWindow(Handle,SW_HIDE); else
    if (!stricmp(Args,"SHOW")) ShowWindow(Handle,SW_SHOW);
    return;
}


//**************************************************************************************************
void ShowCommandLineInfo(void) {
    printf("WAPI v%s (Windows API for DOS Applications)\n",_kWAPI_VERSION);
    printf("---------------------------------------------\n"
           "                        2007, Paulo Buzinello\n"
           "                     http://prg.buzinello.com\n"
           "        http://pub.buzinello.com/clipper/libs\n"
           "                          paulo@buzinello.com\n"
           "                                  Londrina/PR\n"
           "                                       Brazil\n"
           "---------------------------------------------\n"
           );
    return;
}


//**************************************************************************************************
// SMART_GetHDInfo()
//    Salva no arquivo de resultado as informaes do primeiro HD fsico da mquina: modlo, nmero
//    de srie e verso do firmware (separados por vrgulas).
//
void SMART_GetHDInfo(char *FileName) {
    if (!OpenResultFile(FileName)) return;

    HANDLE              hSMART              ; // handle do dispositivo
    GETVERSIONOUTPARAMS VersionParams       ; // buffer com os parmetros de verso deste
    SENDCMDINPARAMS     scip                ; //
    BYTE                bIDCmd              ; // comando de identificao IDE/ATAPI
    DWORD               BytesReturned       ; // quantidade de bytes devolvidos pelo IOCTL
    BOOL                Success             ; //
    int                 Error = _kERROR_NONE; //

    BYTE                IdOutCmd[sizeof(SENDCMDOUTPARAMS)+ // padro da estrutura
                                 IDENTIFY_BUFFER_SIZE-1] ; // extender o tamanho para conter o buffer

    if (IsWindowsNT()) {
        hSMART = CreateFile("\\\\.\\PhysicalDrive0"         ,
                            GENERIC_READ   |GENERIC_WRITE   ,
                            FILE_SHARE_READ|FILE_SHARE_WRITE,
                            NULL                            ,
                            OPEN_EXISTING                   ,
                            0                               ,
                            NULL);
    }
    else {
        hSMART = CreateFile("\\\\.\\SMARTVSD",
                            0                ,
                            0                ,
                            0                ,
                            CREATE_NEW       ,
                            0                ,
                            0);
    }

    if (Success = (hSMART != INVALID_HANDLE_VALUE)) {
        // Obter a verso do dispositivo S.M.A.R.T. (Self Monitoring Analysis and Reporting
        // Technology) para que se possa definir qual cdigo de comando de identificao ser
        // utilizado no presente caso.
        ZeroMemory(&VersionParams,sizeof(VersionParams));
        if (Success = DeviceIoControl(hSMART               ,
                                      DFP_GET_VERSION      ,
                                      NULL                 ,
                                      0                    ,
                                      &VersionParams       ,
                                      sizeof(VersionParams),
                                      &BytesReturned       ,
                                      NULL                 )) {

            // Leitura do setor de identificao do disco
            // O cdigo do comando de leitura ser diferenciado, conforme for ATAPI ou no
            bIDCmd = (VersionParams.bIDEDeviceMap >> 0 & 0x10) ? IDE_ATAPI_ID : IDE_ID_FUNCTION;
            ZeroMemory(&scip,sizeof(scip));
            ZeroMemory(&IdOutCmd,sizeof(IdOutCmd));

            if (Success = SMART_GetIdentify(hSMART                      ,
                                            &scip                       ,
                                            (PSENDCMDOUTPARAMS)&IdOutCmd,
                                            bIDCmd                      ,
                                            0                           ,
                                            &BytesReturned)             ) {
            }
            else Error = _kERROR_SMART_IDENTIFY;
        }
        else Error = _kERROR_SMART_VERSION;
    }
    else Error = _kERROR_SMART_OPEN_DEVICE;

    CloseHandle(hSMART);

    fprintf(ResultFileHandle,"%d",Error);
    if (Success) {
        SMART_WriteInfo((PIDSECTOR)((PSENDCMDOUTPARAMS)IdOutCmd)->bBuffer);
    }
    CloseResultFile();
    return;
}


//**************************************************************************************************
BOOL SMART_GetIdentify(HANDLE hSMART           ,
                       PSENDCMDINPARAMS pSCIP  ,
                       PSENDCMDOUTPARAMS pSCOP ,
                       BYTE bIDCmd             ,
                       BYTE bDriveNum          ,
                       PDWORD lpBytesReturned) {

    // Configurar a estrutura de dados para emitir o comando IDENTIFY.
    pSCIP->cBufferSize = IDENTIFY_BUFFER_SIZE;
    pSCIP->irDriveRegs.bFeaturesReg     = 0  ;
    pSCIP->irDriveRegs.bSectorCountReg  = 1  ;
    pSCIP->irDriveRegs.bSectorNumberReg = 1  ;
    pSCIP->irDriveRegs.bCylLowReg       = 0  ;
    pSCIP->irDriveRegs.bCylHighReg      = 0  ;

    pSCIP->irDriveRegs.bDriveHeadReg = 0xA0 | ((bDriveNum & 1) << 4);

    // O comando tanto pode ser de identificao IDE ou ATAPI.
    pSCIP->irDriveRegs.bCommandReg = bIDCmd  ;
    pSCIP->bDriveNumber = bDriveNum          ;
    pSCIP->cBufferSize = IDENTIFY_BUFFER_SIZE;

    return DeviceIoControl(hSMART,
                           DFP_RECEIVE_DRIVE_DATA                         ,
                           (LPVOID)pSCIP                                  ,
                           sizeof(SENDCMDINPARAMS)-1                      ,
                           (LPVOID)pSCOP                                  ,
                           sizeof(SENDCMDOUTPARAMS)+IDENTIFY_BUFFER_SIZE-1,
                           lpBytesReturned                                ,
                           NULL
                           );
}


//**************************************************************************************************
void SMART_PrepareInfo(char *String, int Size) {
    char Temp;
    int  i;

    for(i=0; i<Size; i+=2) {
        Temp = String[i];
        String[i  ] = String[i+1];
        String[i+1] = Temp;
    }
    //
    // Remover os espaos excedentes da string
    for(i=Size-1; i>1; i--) {
       if (String[i] != 32) break;
       String[i] = '\0';
    }
    return;
}


//**************************************************************************************************
void SMART_WriteInfo(PIDSECTOR ID) {
    char Output[64];

    SMART_PrepareInfo(ID->sModelNumber,sizeof(ID->sModelNumber));
    strncpy(Output,ID->sModelNumber,sizeof(ID->sModelNumber));
    strcat(Output,",");

    SMART_PrepareInfo(ID->sSerialNumber,sizeof(ID->sSerialNumber));
    strncat(Output,ID->sSerialNumber,sizeof(ID->sSerialNumber));
    strcat(Output,",");

    SMART_PrepareInfo(ID->sFirmwareRev,sizeof(ID->sFirmwareRev));
    strncat(Output,ID->sFirmwareRev,sizeof(ID->sFirmwareRev));
    strcat(Output,",");

    fprintf(ResultFileHandle,"%s",Output);
    return;
}


//**************************************************************************************************
// URL2File()
//    Realiza o download de um arquivo pela Internet, conforme a URL fornecida. Recebe tambm um
//    valor de tempo de espera, em segundos (0 para infinito).
//
HANDLE    ConnectEvent    ;
HANDLE    ReqOpenEvent    ;
HANDLE    ReqCompleteEvent;
HINTERNET InternetHandle  ;
HINTERNET ConnectHandle   ;
HINTERNET RequestHandle   ;
BOOL      U2FDone = FALSE ;

void URL2File(char* Args) {
    if (!CheckArgs(Args,4)) return;

    char *URL        =        strtok(Args,_kARGS_SEP)      ;
    char *DataFile   =        strtok(NULL,_kARGS_SEP)      ;
    int   TimeOut    =   atoi(strtok(NULL,_kARGS_SEP))*1000; // milisegundos
    char *ResultFile =        strtok(NULL,_kARGS_SEP)      ;
    int   Error      = _kERROR_NONE                        ;
    char *TargetObj  ;
    char *ServerAddr ;
    char *Temp       ;

    if (!OpenResultFile(ResultFile)) return;

    // Eliminao do identificador de protocolo (HTTP), se houver,
    // alm do desmembramento dos nomes do servidor e objeto alvo.
    if (strnicmp(URL,"http://",7)==0) URL += 7;
    TargetObj  = malloc(sizeof(char)*strlen(URL));
    ServerAddr = strtok(URL,"/");
    Temp       = ServerAddr+strlen(ServerAddr)+1;
    strcpy(TargetObj,"/");
    strcpy(TargetObj+1,Temp);

    if (strlen(TargetObj)<2) {
        Error = _kERROR_PARAMETERS;
    }
    else {
        //  desaconselhvel utilizar um tempo muito extenso, e muito menos o tempo zero
        // (infinito), uma vez que se o tempo for prolongado demais quando desconectado,
        //  possvel que haja um retorno sem o erro WAIT_TIMEOUT, o que logicamente vai
        // gerar um retorno bem-sucedido.
        if (TimeOut == 0) TimeOut = 0xFFFFFFFF;

        // Criao dos eventos monitorados pela funo Callback.
        // Esses eventos sero automaticamente fechados quando o processo for finalizado.
        ConnectEvent     = CreateEvent(NULL,FALSE,FALSE,NULL);
        ReqOpenEvent     = CreateEvent(NULL,FALSE,FALSE,NULL);
        ReqCompleteEvent = CreateEvent(NULL,FALSE,FALSE,NULL);

        // Inicializar o uso da API WinInet.
        InternetHandle = InternetOpen("WAPI_U2F"                  ,
                                      INTERNET_OPEN_TYPE_PRECONFIG,
                                      NULL                        ,
                                      NULL                        ,
                                      INTERNET_FLAG_ASYNC        );

        if (!InternetHandle) {
            Error = _kERROR_UNKNOWN;
        }
        else {
            // Configurar a funo Callback que ir tratar os eventos.
            InternetSetStatusCallback(InternetHandle,(INTERNET_STATUS_CALLBACK)&URL2FileCallback);

            // Abrir a conexo com a Internet.
            ConnectHandle = InternetConnect(InternetHandle            ,
                                            ServerAddr                ,
                                            INTERNET_DEFAULT_HTTP_PORT,
                                            NULL                      ,
                                            NULL                      ,
                                            INTERNET_SERVICE_HTTP     ,
                                            0                         ,
                                            1                        ); // identificador de contexto
            if (!ConnectHandle) {
                if (GetLastError() != ERROR_IO_PENDING) Error = _kERROR_UNKNOWN; else
                if (WaitForSingleObject(ConnectEvent,TimeOut) == WAIT_TIMEOUT) Error = _kERROR_TIMEOUT;
            }
            if (Error == _kERROR_NONE) {
                // Abrir a conexo HTTP para o objeto alvo (URL).
                RequestHandle = HttpOpenRequest(ConnectHandle                                      ,
                                                "GET"                                              ,
                                                TargetObj                                          ,
                                                NULL                                               ,
                                                NULL                                               ,
                                                NULL                                               ,
                                                INTERNET_FLAG_RELOAD | INTERNET_FLAG_NO_CACHE_WRITE,
                                                2                                                 ); // identificador de contexto
                if (!RequestHandle) {
                    if (GetLastError() != ERROR_IO_PENDING) Error = _kERROR_UNKNOWN; else
                    if (WaitForSingleObject(ReqOpenEvent,TimeOut) == WAIT_TIMEOUT) Error = _kERROR_TIMEOUT;
                }
                if (Error == _kERROR_NONE) {
                    // Transmitir o comando GET para o servidor HTTP.
                    if (!HttpSendRequest(RequestHandle,NULL,0,NULL,0)) {
                        if (GetLastError() != ERROR_IO_PENDING) Error = _kERROR_UNKNOWN; else
                        if (WaitForSingleObject(ReqCompleteEvent,TimeOut) == WAIT_TIMEOUT) Error = _kERROR_TIMEOUT;
                    }
                    if (Error == _kERROR_NONE) {
                        #define _kPACKET_LEN 4*1024

                        INTERNET_BUFFERS InetBuffer;
                        FILE            *DataFileHandle = fopen(DataFile,"w+b");
                        char             DataBuffer[_kPACKET_LEN];

                        // Ler/salvar os pacotes de dados.
                        do {
                            ZeroMemory(&InetBuffer,sizeof(InetBuffer));
                            InetBuffer.dwStructSize   = sizeof(InetBuffer);
                            InetBuffer.lpvBuffer      =        DataBuffer ;
                            InetBuffer.dwBufferLength = sizeof(DataBuffer);

                            if (!InternetReadFileEx(RequestHandle,&InetBuffer,0,2)) {
                                ResetEvent(ReqCompleteEvent);
                                if (GetLastError() != ERROR_IO_PENDING) Error = _kERROR_UNKNOWN; else
                                if (WaitForSingleObject(ReqCompleteEvent,TimeOut) == WAIT_TIMEOUT) Error = _kERROR_TIMEOUT;
                            }
                            if (Error != _kERROR_NONE) break;

                            fwrite(DataBuffer,sizeof(char),InetBuffer.dwBufferLength,DataFileHandle);

                            DataBuffer[InetBuffer.dwBufferLength] = 0;
                            U2FDone = InetBuffer.dwBufferLength == 0;

                        } while(!U2FDone);
                        fclose(DataFileHandle);
                    }
                    InternetCloseHandle(RequestHandle);
                }
                InternetCloseHandle(ConnectHandle);
            }
            InternetCloseHandle(InternetHandle);
        }
    }

    free(TargetObj);

    fprintf(ResultFileHandle,"%d",Error);
    CloseResultFile();
    return;
}


//**************************************************************************************************
void WINAPI URL2FileCallback(HINTERNET Instance, DWORD ContextID, DWORD InternetStatus, LPVOID StatusInfo, DWORD StatusInfoLen) {
    switch(ContextID) {
        case 1: {
             if (InternetStatus == INTERNET_STATUS_HANDLE_CREATED) {
                 INTERNET_ASYNC_RESULT *pRes = (INTERNET_ASYNC_RESULT*)StatusInfo;
                 ConnectHandle = (HINTERNET)pRes->dwResult;
                 SetEvent(ConnectEvent);
             }
             break;
        }
        case 2: {
             switch(InternetStatus) {
                 case INTERNET_STATUS_HANDLE_CREATED: {
                      INTERNET_ASYNC_RESULT *pRes = (INTERNET_ASYNC_RESULT*)StatusInfo;
                      RequestHandle = (HINTERNET)pRes->dwResult;
                      SetEvent(ReqOpenEvent);
                      break;
                 }
                 case INTERNET_STATUS_REQUEST_SENT: {
                      break;
                 }
                 case INTERNET_STATUS_REQUEST_COMPLETE: {
                      SetEvent(ReqCompleteEvent);
                      break;
                 }
                 case INTERNET_STATUS_RECEIVING_RESPONSE: {
                      break;
                 }
                 case INTERNET_STATUS_RESPONSE_RECEIVED: {
                      DWORD *dwBytesReceived = (DWORD*)StatusInfo;
                      if (*dwBytesReceived == 0) {
                          U2FDone = TRUE;
                      }
                 }
             }
        }
    }
    return;
}


//**************************************************************************************************
// WindowsSleep()
//    Suspende ou coloca o sistema operacional para hibernar, conforme o modo informado.
//
void WindowsSleep(BOOL Mode) {
    SetPrivilege();
    SetSystemPowerState(Mode,FALSE);
    return;
}


//************************************************************************************************************
// WriteRegistry()
//    Grava no Registry do Windows uma entrada e seu valor na chave informada, que ser criada, se
//    necessrio. Podero ser criadas tambm todas as chaves inexistentes no caminho informado. O
//    arquivo de resultado conter apenas o cdigo que identifica o sucesso da operao, ou um
//    entre dois cdigos: erro nos parmetros ou erro desconhecido.
//
void WriteRegistry(char *Args) {
    if (!CheckArgs(Args,5)) return;

    char  *RootKeyID  = strtok(Args,_kARGS_SEP); // inicialmente conter o caminho completo
    char  *KeyPath    = RootKeyID              ; //
    char  *EntryName  = strtok(NULL,_kARGS_SEP); //
    char  *DataType   = strtok(NULL,_kARGS_SEP); // (B)inrio, (C)aractere, (N)umrico ou (T)exto
    char  *Data       = strtok(NULL,_kARGS_SEP); // dado (inicialmente, string)
    char  *MPtr       = NULL                   ; // ponteiro da memria eventualmente alocada
    DWORD  Number                              ; // nmero convertido a partir de Data (se numrico)
    char  *BinDat                              ; // string de um possvel valor binrio
    char  *ResultFile = strtok(NULL,_kARGS_SEP); //
    int    Error      = _kERROR_NONE           ; //
    int    Size                                ; //
    int    i                                   ; //
    int    k                                   ; //

    if (!OpenResultFile(ResultFile)) return;

    HKEY  RootKey    ; // handle da raiz da chave
    HKEY  Handle     ; // handle da chave que ser aberta (e/ou criada)
    DWORD Disposition; // neste caso, apenas perfumaria :)

    // Separao da raiz do resto do caminho da(s) chave(s)
    RootKeyID = strtok(RootKeyID,"\\");
    KeyPath  += strlen(RootKeyID)+1;
    RootKey   = RegistryRootByName(RootKeyID);
    if (RootKey == NULL) {
        Error = _kERROR_PARAMETERS;
    }

    if (Error == _kERROR_NONE) {
        Error = RegCreateKeyEx(RootKey                ,
                               KeyPath                ,
                               0                      ,
                               0                      ,
                               REG_OPTION_NON_VOLATILE,
                               KEY_SET_VALUE          ,
                               NULL                   ,
                               &Handle                ,
                               &Disposition
                               );
    }

    if (Error == _kERROR_NONE) {
        switch(strupr(DataType)[0]) {
            case 'B': {
                 BinDat = strtok(Data,",");
                 i = 0;
                 while(BinDat) {
                    Data[i] = atoi(BinDat);
                    BinDat  = strtok(NULL,",");
                    i++;
                 }
                 Error = RegSetValueEx(Handle,EntryName,0,REG_BINARY,Data,i);
                 break;
            }
            case 'C': {
                 Error = RegSetValueEx(Handle,EntryName,0,REG_SZ,Data,strlen(Data)+1);
                 break;
            }
            case 'N': {
                 Number = atol(Data); // padro Windows: little-endian
                 Error  = RegSetValueEx(Handle,EntryName,0,REG_DWORD,(BYTE*)&Number,sizeof(Number));
            }
            case 'T': {
                 if (!strnicmp(Data,"%F:",3)) {
                     // A abertura do arquivo no modo binrio evitar a traduo de CR/LF para LF.
                     FILE *Handle = fopen(Data+3,"rb");
                     if (Handle) {
                         fseek(Handle,0L,SEEK_END);
                         Size = ftell(Handle);
                         fseek(Handle,0L,SEEK_SET);
                         Data = MPtr = malloc((sizeof(char)*Size)+2);
                         if (Data) {
                             fread(Data,sizeof(char),Size,Handle);
                             Data[Size] = '\0';
                         }
                         else Error = _kERROR_MEMORY;
                         fclose(Handle);
                     }
                     else Error = _kERROR_OPEN_INPUTFILE;
                 }
                 else {
                     char *Ptr;
                     while(Ptr = strstr(Data,"@@")) {
                        *Ptr++ = 13;
                        *Ptr   = 10;
                     }
                 }
                 //
                 // Compresso do arquivo com a troca do par CR/LF por \0. Na seqncia, a gravao.
                 if (Error == _kERROR_NONE) {
                     Size = strlen(Data);
                     k = 0;
                     for(i=0; i<Size-k; i++) {
                         Data[i] = Data[i+k];
                         if (Data[i+k] == 13 && Data[i+k+1] == 10) {
                             Data[i] = '\0';
                             k++;
                         }
                     }
                     Data[i  ] = '\0';
                     Data[i+1] = '\0';

                     Error = RegSetValueEx(Handle,EntryName,0,REG_MULTI_SZ,Data,Size-k+1);
                     if (MPtr) free(MPtr);
                 }
            }
        }
        RegCloseKey(Handle);
    }
    fprintf(ResultFileHandle,"%d",(Error==ERROR_SUCCESS? _kERROR_NONE: _kERROR_UNKNOWN));
    CloseResultFile();
    return;
}


//**************************************************************************************************
// WriteResultFileResult()
//    Escreve no arquivo de resultado um cdigo numrico de resultado final, fechando o arquivo.
//
void WriteResultFileResult(int ResultCode) {
    fprintf(ResultFileHandle,"%d",ResultCode);
    CloseResultFile();
    return;
}
